/* pipe-sim(+vector) ver.3.0 [92/05/28-7/29] */
/* chaining network */

#include "defines.h"
#include "latches.h"
#include "cmnvar.h"
#include "opcode.h"

static word chainnet[NCN][CNLEN_L];
static int chainnet_top[NCN];
static char cn_in_status[NCN][SSLEN];
static char cn_out_status[NCN][SSLEN];

void cninit()	/* vector integer/logic pipe initialize */
{
	int	cn,i;

	for ( cn = 0 ; cn < NCN ; cn++) {
		chainnet_in[cn].i = chainnet_out[cn].i = 0;
		chainnet_top[cn] = 0;
		for (i=0 ; i < CNLEN_L ; i++) chainnet[cn][i].i = 0;
	}
}

char *cn_out(cn) /* chainnet -> chainnet_out_latch */
int cn;
{
	chainnet_out[cn] = chainnet[cn][chainnet_top[cn]];

	/* return status */
	sprintf(cn_out_status[cn],
		"output %10d(%10.4f)",
		chainnet_out[cn].i,
		chainnet_out[cn].f);
	return (cn_out_status[cn]);
}
	
char *cn_in(cn)/*  chainnet_in_latche -> chainnet */
int	cn;
{
	word	in_value;

	chainnet[cn][chainnet_top[cn]] = chainnet_in[cn] ;
	in_value = chainnet_in[cn] ;
	chainnet_in[cn].i = 0;
	if (cn < (NCN / 2)) {
		/* 0 <= cn < NCN/2 : short delay (CNLEN_S) */
		if (--chainnet_top[cn] < 0) chainnet_top[cn]=CNLEN_S-1;
	} else {
		/* NCN/2 <= cn < NCN : long delay (CNLEN_L) */
		if (--chainnet_top[cn] < 0) chainnet_top[cn]=CNLEN_L-1;
	}

	/* return status */
	sprintf(cn_in_status[cn],
		"input %10d(%10.4f)",
		chainnet_in[cn].i,
		chainnet_in[cn].f);
	return (cn_in_status[cn]);
}
