/***
 ***    ps3v ver.3.5a-R1.0 [92/Oct/25] by kata.
 ***    ps4v ver.4.0	   [94/May/30-94/Jun/15] by kata.
 ***    ps4v ver.4.0a	   [94/Jun/16-94/Jun/] by kata.
 ***         ver.4.0a	   [94/Dec/03-] by kata.
 ***
 ***    check register write collision procedure.
 ***    check register number procedure.
 ***
 ***/

#include <stdio.h>
#include <stdlib.h>
#include "defines.h"
#include "regdef.h"
#include "register_set.h"

static char errstr[100]; /* error message temp. */

global_check(ip,no)
int ip,no;
{
	if ((no < 0) || (no >= GLOBAL)) {
		sprintf (errstr,"invalid GLOBAL register No.%d",no);
		error(errstr,"reg_read/write",ip);
		return;
	}
}

#ifdef BANKED
overlap_check(ip,no)
int ip,no;
{
	if ((no < 0) || (no >= OVERLAP)) {
		sprintf (errstr,"invalid OVERLAP register No.%d",no);
		error(errstr,"reg_read/write",ip);
		return;
	}
}

banked_check(ip,no)
int ip,no;
{
	if ((no < 0) || (no >= LOCAL)) {
		sprintf (errstr,"invalid LOCAL register No.%d",no);
		error(errstr,"reg_read/write",ip);
		return;
	}
}
#endif

check_reg()
{
	int max_collision = 0;

	/* check WB stage write collision */

	if ( global_write_count_wb  > 1 ) {
		if (max_collision < (global_write_count_wb - 1)) {
		    max_collision = global_write_count_wb - 1;
		}
	}

#ifdef BANKED
	if ( bankreg0_write_count_wb > 1 ) {
		if (max_collision < (bankreg0_write_count_wb - 1)) {
		    max_collision = bankreg0_write_count_wb- 1;
		}
	}
	if ( bankreg1_write_count_wb > 1 ) {
		if (max_collision < (bankreg1_write_count_wb - 1)) {
		    max_collision = bankreg1_write_count_wb- 1;
		}
	}
	if ( bankreg2_write_count_wb > 1 ) {
		if (max_collision < (bankreg2_write_count_wb - 1)) {
		    max_collision = bankreg2_write_count_wb- 1;
		}
	}
	if ( bankreg3_write_count_wb > 1 ) {
		if (max_collision < (bankreg3_write_count_wb - 1)) {
		    max_collision = bankreg3_write_count_wb- 1;
		}
	}

	if ( overlap0_write_count_wb > 1 ) {
		if (max_collision < (overlap0_write_count_wb - 1)) {
		    max_collision = overlap0_write_count_wb - 1;
		}
	}
	if ( overlap1_write_count_wb > 1 ) {
		if (max_collision < (overlap1_write_count_wb - 1)) {
		    max_collision = overlap1_write_count_wb - 1;
		}
	}
	if ( overlap2_write_count_wb > 1 ) {
		if (max_collision < (overlap2_write_count_wb - 1)) {
		    max_collision = overlap2_write_count_wb - 1;
		}
	}
	if ( overlap3_write_count_wb > 1 ) {
		if (max_collision < (overlap3_write_count_wb - 1)) {
		    max_collision = overlap3_write_count_wb - 1;
		}
	}
#endif

	/* check FWB stage write collision */

	if ( global_write_count_fwb  > 1 ) {
		if (max_collision < (global_write_count_fwb - 1)) {
		    max_collision = global_write_count_fwb - 1;
		}
	}

#ifdef BANKED
	if ( bankreg0_write_count_fwb > 1 ) {
		if (max_collision < (bankreg0_write_count_fwb - 1)) {
		    max_collision = bankreg0_write_count_fwb- 1;
		}
	}
	if ( bankreg1_write_count_fwb > 1 ) {
		if (max_collision < (bankreg1_write_count_fwb - 1)) {
		    max_collision = bankreg1_write_count_fwb- 1;
		}
	}
	if ( bankreg2_write_count_fwb > 1 ) {
		if (max_collision < (bankreg2_write_count_fwb - 1)) {
		    max_collision = bankreg2_write_count_fwb- 1;
		}
	}
	if ( bankreg3_write_count_fwb > 1 ) {
		if (max_collision < (bankreg3_write_count_fwb - 1)) {
		    max_collision = bankreg3_write_count_fwb- 1;
		}
	}

	if ( overlap0_write_count_fwb > 1 ) {
		if (max_collision < (overlap0_write_count_fwb - 1)) {
		    max_collision = overlap0_write_count_fwb - 1;
		}
	}
	if ( overlap1_write_count_fwb > 1 ) {
		if (max_collision < (overlap1_write_count_fwb - 1)) {
		    max_collision = overlap1_write_count_fwb - 1;
		}
	}
	if ( overlap2_write_count_fwb > 1 ) {
		if (max_collision < (overlap2_write_count_fwb - 1)) {
		    max_collision = overlap2_write_count_fwb - 1;
		}
	}
	if ( overlap3_write_count_fwb > 1 ) {
		if (max_collision < (overlap3_write_count_fwb - 1)) {
		    max_collision = overlap3_write_count_fwb - 1;
		}
	}
#endif

	write_collision += max_collision;

	clear_write_count() ;

}
