/* pipe-sim(+vector) ver.4.0 [94/05/30-6/15] */
/* 		     ver.4.0c[94/11/18] */
/* 		     ver.4.2 [94/12/19] */
/* 		     ver.4.3 [94/12/26-95/01/20] */
/* define global variables & macros      */

#include "global.h"
#include "specialreg.h"

/* global  variables */

/* condition code = FRAGREG(reg130) bit0-7 */
/* bit0(LSB)-1=ip0,bit2-3=ip1,bit4-5=ip2,bit6-7=ip3 */
/* pn = Instruction pipe number(0~3) */
#define CC(pn)	((specialregfile[N_FR-SPECIALBASE].i>>((pn)<<1))&3)

/* special register file */
global word specialregfile[SPECIALREGS];
#define SPECIALREG(reg) specialregfile[(reg)-SPECIALBASE]

/* main memory */
global word memory[MEMSIZE];

/* special registers */
#define ZEROREG(pn) reg_read(pn,0)	 /* zero register = reg0 */
#define	PC	    SPECIALREG(PCREGNO).i
#define	FLAGREG     SPECIALREG(N_FR).i

/* vector registers */
global word vectorreg[VREGSIZE][VREGLEN];

/* vector mask registers */
global int vmaskreg[VMRSIZE][VREGLEN/sizeof(int)];

/* get & set vector mask register */
#define VMR(vmr_no,pos) ((vmaskreg[(vmr_no)][(int)((pos)/sizeof(int))]>>((pos)%sizeof(int)))&1)
#define setVMR(vmr_no,pos,value) vmaskreg[(vmr_no)][(int)((pos)/sizeof(int))]=vmaskreg[(vmr_no)][(int)((pos)/sizeof(int))]|((value)<<((pos)%sizeof(int)))

/* status strings */
global char *if_ss[NIP],*id_ss[NIP];
global char *alu_ss[NIP],*mem_ss[NIP],*wb_ss[NIP],*fwb_ss[NIP];
global char *lu_ss[NIP],*su_ss[NIP];
global char *vlu_ss[NIP],*vsu_ss[NIP];
global char *fasp_in_ss[NFASP],*faspctl_ss[NFASP];
global char *fmp_in_ss[NFMP],*fmpctl_ss[NFMP];
global char *fdp_in_ss[NFDP],*fdpctl_ss[NFDP];
global char *vilp_in_ss[NVILP],*vilpctl_ss[NVILP];
global char *cn_out_ss[NCN],*cn_in_ss[NCN];

/* batch mode flag */
global int batchmode;
