/* pipe-sim(+vector) ver.3.0 [92/05/28-7/29] */
/* 		     ver.3.2 [92/08/27-8/29] */
/* 		     ver.3.3 [92/09/03-9/10] */
/* 		     ver.3.4 [92/09/14] */
/* 		     ver.3.4a[92/09/16] */
/* 		     ver.3.5 [92/12/14] */
/* 					     */
/* pipe-sim(+vector) ver.4.0 [94/05/30-6/15] */
/* 		     ver.4.3 [94/12/26-95/01/20] */
/* header file for debugger procedures */

#include "global.h"

#define	HALT_END 0	/* terminated by HALT instruction */
#define	ERROR_END 1	/* terminated by Run-time ERROR */
#define BREAK_STOP 2	/* stopped by BREAKPOINT/BREAKCYCLE */
#define INTERRUPT 3	/* stopped by INTERRUPT */

#define	CMD_RUN	0	/* debugger RUN command */
#define	CMD_INIT 1	/* debugger INIT command */
#define	CMD_TRACE 2	/* debugger TRACE command */
#define	CMD_CONT 3	/* debugger CONT command */
#define	CMD_DISPSR 4	/* debugger DISPSR command */
#define	CMD_DISPVR 5	/* debugger DISPVR command */
#define	CMD_DISPMEM 6	/* debugger DISPMEM command */
#define	CMD_DISPVMR 7	/* debugger DISPVMR command */
#define	CMD_BREAKPOINT 8 /* debugger BREAKPOINT command */
#define	CMD_CLEARBP 9	/* debugger CLEARBP command */
#define	CMD_QUIT 10	/* debugger QUIT command */
#define	CMD_WAIT 11	/* debugger WAIT command */
#define	CMD_STEP 12	/* debugger STEP command */
#define	CMD_STATUS 13	/* debugger STATUS command */
#define	CMD_LOAD 14	/* debugger LOAD command */
#define	CMD_DUMPMEM 15	/* debugger DUMPMEM command */
#define	CMD_BREAKCYCLE 16 /* debugger BREAKCYCLE command */
#define	CMD_CLEARBC 17	/* debugger CLEARBC command */
#define	CMD_ERROR -1	/* illegal debugger command */

typedef struct {	/* struct for debugger commands */
	int	type;	/* command type number */
	char	*str;	/* command string */
} cmd_struct;

#ifdef MAINPROGRAM
cmd_struct cmdtable[]={
	{CMD_RUN,"run"},
	{CMD_INIT,"init"},
	{CMD_TRACE,"trace"},
	{CMD_CONT,"cont"},
	{CMD_DISPSR,"dsr"},
	{CMD_DISPVR,"dvr"},
	{CMD_DISPMEM,"dmem"},
	{CMD_DISPVMR,"dvmr"},
	{CMD_BREAKPOINT,"bp"},
	{CMD_CLEARBP,"clearbp"},
	{CMD_WAIT,"wait"},
	{CMD_STEP,"step"},
	{CMD_STATUS,"status"},
	{CMD_LOAD,"load"},
	{CMD_DUMPMEM,"dumpmem"},
	{CMD_QUIT,"quit"},
	{CMD_BREAKCYCLE,"bc"},
	{CMD_CLEARBC,"clearbc"},
	{CMD_ERROR,""}
};
#else
extern	cmd_struct cmdtable[];
#endif

typedef struct {	/* struct for breakpoint */
	int	address;	/* breakpoint address */
	int	enable;		/* enable flag */
	int	count;		/* counter (for future extention) */
	int	limit;		/* limit count (for future extention) */
} bp_struct;

global bp_struct breakpoint;	/* breakpoint */

typedef struct {	/* struct for breakcycle */
	int	cycle;	/* breakcycle */
	int	enable;	/* enable flag */
} bc_struct;

global bc_struct breakcycle;	/* breakcycle */

global int cycle init(0);	/* executed cycle */
global int interruptflag init(FALSE);	/* keybord interrupt flag */
global int stepexec init(FALSE);/* step execution flag */

global char objfile[256];	/* object file name */

extern int checkbreakpoint();	/* breakpoint checking routine */
extern int checkbreakcycle();	/* breakcycle checking routine */

extern void interrupt();	/* keybord interrupt handler */
