/* pipe-sim(+vector) ver.4.0 [94/05/30-6/15] */
/* 		     ver.4.3 [94/12/26-95/01/20] */
/* 		     ver.4.3f[97/01/23,97/02/07] */
/* define constants & struct typedefs.   */

#include "global.h"

/* constant defines */
#undef	TRUE
#undef	FALSE
#define TRUE	1
#define FALSE	0

/* Status String LENgth */
#define SSLEN	256

#ifdef MP4V
#include "ipconst-mp4v.h"
#else
#include "ipconst-ps3v.h"
#endif

/* pipeline length */
#define FASPLEN	3	/* Floating Add/Sub Pipe LENgth */
#define FMPLEN	5	/* Floating Mult Pipe LENgth */
#define FDPLEN	5	/* Floating Div Pipe LENgth */
#define VILPLEN	2	/* Vector Integer/Logical Pipe LENgth */

/* number and length(delay) of chaining  networks */
#define NCN	8	/* Number of Chaining Networks */
#define CNLEN_S	2	/* Chaining Net LENgth-Short(short delay chaainnet) */
#define CNLEN_L	4	/* Chaining Net LENgth-Long (long  delay chaainnet) */

/* Condition Codes (CC = [signflag][zeroflag]) */
#define PLUS	0	/* CC = 00 */ 
#define ZERO	1	/* CC = 01 */
#define MINUS	2 	/* CC = 10 */

/* scalar register size(including special registers) */
#define REGSIZE	256	/* register file size (8+(8+14+8)*4)+128(special regs) */

/* vector register size */
#define VREGSIZE	64	/* vector register size */
#define VREGLEN 	128	/* vector register length */
#define VMRSIZE 	8	/* vector mask register size */

/* memory size */
#define PMSIZE	4194304	/* program memory size (4M) */
#define DMSIZE	4194304	/* data memory size (4M) */
#define MEMSIZE	(PMSIZE+DMSIZE)	/* total memory size */

#define HALT	(1<<8)	/* halt flag bit */
#define ERROR	(1<<9)	/* error flag bit */

/* struct type defines */

typedef union {
	int	i;
	unsigned int	u;
	float	f;
} word;

typedef struct {
	int	address;
	int	optype;
	int	subtype1;
	int	subtype2;
	int	subtype3;
	int	alu_operation;
	int	jump_taken;
	int	src1;
	int	src2;
	int	dstn;
	int	vmr;
} decoded_inst;

typedef struct {
	int	regsrc;
	int	regdst;
	int	src;
	int	dst;
	word	val;
} reglatch;

/* reglatch regsrc/regdst flags */
/* FALSE = not registers */
/* TRUE =  scalar registers */
/* VREG =  vector registers */
#define VREG 2
/* CNET =  vector chaining network */
#define CNET 3
/* SETVMR =  set condition to VMR */
#define SETVMR 4
