/* pipe-sim(+vector) ver.4.0 [94/05/30-6/15] */
/* header file for display procedures */

#include "global.h"

#define	COMMANDLINE	0	/* top line of command input area */
#define	ERRORLINE	3	/* top line of error message display area */
#define	CYCLELINE	4	/* top line of cycle&phase display area */
#define FLAGLINE	5	/* top line of flag display area */
#define REGMEMLINE	8	/* top line of register/memory display area */
#define VMRLINE		20	/* top line of VMR display area */
#define STATUSLINE	23	/* top line of status display area */

#define	DISPSR	0	/* display SR on REGMEM area */
#define DISPVR	1	/* display VR on REGMEM area */
#define DISPMEM	2	/* display MEM on REGMEM area */

global	int	statusdisp init(TRUE);	/* status display flag */

global	int	regmemdisp init(DISPSR);/* REGMEM area display flag */

global	int	SRdisptop init(0);	/* scalar reg. display start No. */

global	int	VRdispnum init(0);	/* vector reg. display No. */
global	int	VRdisptop init(0);	/* vector reg. display start element No. */

global	int	memdisptop init(0);	/* memory display start address */

global	int	VMRdispnum init(1);	/* vector mask reg. display No. */

global	int	waittime init(100000); /* wait time(microsec) after refresh */

extern	void	clearline();	/* clear specified line */
extern	void	dispsr();	/* display scalar registers */
extern	void	dispvr();	/* display vector registers */
extern	void	dispmem();	/* display memories */
extern	void	dispvmr();	/* display vector mask registers */
