/* pipe-sim(+vector) ver.4.0 [94/05/30-06/15] */
/* 		     ver.4.3 [94/12/26-95/01/20] */
/* floating pipeline (div) */

#include "defines.h"
#include "latches.h"
#include "cmnvar.h"
#include "opcode.h"

static reglatch	fdp[NFDP][FDPLEN],fdp_clear;
static int	fdptop[NFDP];

static char     fdpstate[NFDP][SSLEN];
static char     fdp_outstate[NFDP][30];

void fdpinit()	/* floating div pipe initialize */
{
	int	fp,i;

        /* initialize for fdp clear structure */
        fdp_clear.val.f = 0.0;
        fdp_clear.regsrc = FALSE;
        fdp_clear.src = 0;
        fdp_clear.regdst = FALSE;
        fdp_clear.dst = 0;

        /* initializing fdp */

	for ( fp = 0 ; fp < NFDP ; fp++) {
		fd_op[fp] = FOP_NOP;
		fdpin1[fp] = fdpin2[fp] = fdpout[fp] = fdp_clear;
		fdptop[fp] = 0;
		for (i=0 ; i < FDPLEN ; i++) fdp[fp][i] = fdp_clear;
	}
}

void fdp_out(fp) /* fpipe -> fpipe_out_latch */
int fp;
{
	fdpout[fp] = fdp[fp][fdptop[fp]];
	sprintf(fdp_outstate[fp]," ->%6.2f",fdpout[fp].val.f);
	fdp[fp][fdptop[fp]] = fdp_clear;
}
	
char *fdp_in(fp)/*  fpipe_in_latches -> fpipe */
int	fp;
{
        int     lc,t;
        char    fdp_instate[40],fdp_tmpstr[40];
	extern	int cycle;

	switch (fd_op[fp]) {
		case FOP_NOP:	/* do nothing */
                        fdp[fp][fdptop[fp]] = fdp_clear;
                        sprintf(fdp_instate,"(no operation)=");
			fdpin1[fp] = fdpin2[fp] = fdp_clear;
			break;
		case FOP_DIV:	/* floating div */
			if (fdpin1[fp].val.f == 0.0) {
				error("floating point exeption(div by 0)",
				      "fdpipe phase 0",fp);
				break;
			}
			fdp[fp][fdptop[fp]].val.f = fdpin2[fp].val.f / fdpin1[fp].val.f ;
                        fdp[fp][fdptop[fp]].regdst = fdpin1[fp].regdst;
                        fdp[fp][fdptop[fp]].dst = fdpin1[fp].dst ;
                        sprintf(fdp_instate,"%6.2f/%6.2f =",
                                fdpin2[fp].val.f,fdpin1[fp].val.f);
			fd_op[fp] = FOP_NOP;
			fdpin1[fp] = fdpin2[fp] = fdp_clear;
			break;
                default:
                        error("irregal float div pipe operation",
                              "float div pipe",fp);
                        break;
	}

        /* make fdp internal status */
        strcpy(fdpstate[fp],fdp_instate);
        for (lc = fdptop[fp] ; lc < (fdptop[fp]+FDPLEN) ; lc++) {
		t = lc % FDPLEN;
                sprintf(fdp_tmpstr," %6.2f",fdp[fp][t].val.f);
                strcat(fdpstate[fp],fdp_tmpstr);
        }
        strcat (fdpstate[fp],fdp_outstate[fp]);

        /* refresh fdptop pointer */
	if (--fdptop[fp] < 0) fdptop[fp]=FDPLEN-1;

        /* return status */
        return (fdpstate[fp]);
}
