/* pipe-sim(+vector) ver.4.0 [94/05/30-06/15] */
/*		     ver.4.3 [94/12/26-95/01/20] */
/* floating pipeline (mult) */

#include "defines.h"
#include "latches.h"
#include "cmnvar.h"
#include "opcode.h"

static reglatch	fmp[NFMP][FMPLEN],fmp_clear;
static int	fmptop[NFMP];

static char     fmpstate[NFMP][SSLEN];
static char     fmp_outstate[NFMP][30];

void fmpinit()	/* floating mult pipe initialize */
{
	int	fp,i;

        /* initialize for fmp clear structure */
        fmp_clear.val.f = 0.0;
        fmp_clear.regsrc = FALSE;
        fmp_clear.src = 0;
        fmp_clear.regdst = FALSE;
        fmp_clear.dst = 0;

        /* initializing fmp */

	for ( fp = 0 ; fp < NFMP ; fp++) {
		fm_op[fp] = FOP_NOP;
		fmpin1[fp] = fmpin2[fp] = fmpout[fp] = fmp_clear;
		fmptop[fp] = 0;
		for (i=0 ; i < FMPLEN ; i++) fmp[fp][i] = fmp_clear;
	}
}

void fmp_out(fp) /* fpipe -> fpipe_out_latch */
int fp;
{
	fmpout[fp] = fmp[fp][fmptop[fp]];
	sprintf(fmp_outstate[fp]," ->%6.2f",fmpout[fp].val.f);
	fmp[fp][fmptop[fp]] = fmp_clear;
}
	
char *fmp_in(fp)/*  fpipe_in_latches -> fpipe */
int	fp;
{
        int     lc,t;
        char    fmp_instate[40],fmp_tmpstr[40];
	extern	int cycle;

	switch (fm_op[fp]) {
		case FOP_NOP:	/* do nothing */
                        fmp[fp][fmptop[fp]] = fmp_clear;
                        sprintf(fmp_instate,"(no operation)=");
			fmpin1[fp] = fmpin2[fp] = fmp_clear;
			break;
		case FOP_MLT:	/* floating mult */
			fmp[fp][fmptop[fp]].val.f = fmpin2[fp].val.f * fmpin1[fp].val.f ;
                        fmp[fp][fmptop[fp]].regdst = fmpin1[fp].regdst;
                        fmp[fp][fmptop[fp]].dst = fmpin1[fp].dst ;
                        sprintf(fmp_instate,"%6.2f*%6.2f =",
                                fmpin2[fp].val.f,fmpin1[fp].val.f);
			fm_op[fp] = FOP_NOP;
			fmpin1[fp] = fmpin2[fp] = fmp_clear;
			break;
                default:
                        error("irregal float mult pipe operation",
                              "float mult pipe",fp);
                        break;
	}

        /* make fmp internal status */
        strcpy(fmpstate[fp],fmp_instate);
        for (lc = fmptop[fp] ; lc < (fmptop[fp]+FMPLEN) ; lc++) {
		t = lc % FMPLEN;
                sprintf(fmp_tmpstr," %6.2f",fmp[fp][t].val.f);
                strcat(fmpstate[fp],fmp_tmpstr);
        }
        strcat (fmpstate[fp],fmp_outstate[fp]);

        /* refresh fmptop pointer */
	if (--fmptop[fp] < 0) fmptop[fp]=FMPLEN-1;

        /* return status */
        return (fmpstate[fp]);
}
