/* pipe-sim(+vector) ver.4.0 [94/05/30-06/15] */
/* 		     ver.4.0a[94/06/16-06/] */
/* pipeline instruction fetch  stage */

#include "defines.h"
#include "latches.h"
#include "cmnvar.h"
#include "opcode.h"
#include "regdef.h"
#include "register_set.h"
#include "aalu.h"

static char if_0_status[NIP][SSLEN];
static char if_1_status[NIP][SSLEN];
static int  ifcancel1;

char *ifetch0()
{
	int ip;
	static char sstmp[SSLEN];
	int pcloaded;

	jumparb(); /* jump arbitration */
	if (ifcancel!=TRUE) { /* normal inst. fetch */
	    pcloaded = FALSE;
	    for (ip = 0 ; ip < NIP ; ip++) {
		if (jumploadpc[ip]==TRUE) {
		    /* load new PC value (JUMP instruction) */
		    PC = addrALU_out[ip] & PADMASK;
		    jumploadpc[ip] = FALSE;
		    pcloaded = TRUE;

		    /* return status */
		    sprintf(if_0_status[ip],
			    "new PC value is loaded(jump). current PC is 0x%X; ",
			    PC);
		} else {
		    strcpy(if_0_status[ip],"");
		}

	    }
	    if (pcloaded == FALSE) { /* pc not yet loaded (no jump instruction) */
		PC = addrALU_out[0] & PADMASK;
		/* return status */
		sprintf(if_0_status[0],
			"new PC value is loaded(next). current PC is 0x%X; ",
			PC);
	    }

	    for (ip = 0 ; ip < NIP ; ip++) {
		/* send PC to PMAR */
		pmar[ip] = PC+ip;

		/* return status */
		sprintf(sstmp,"pmar[%1d] is 0x%X",ip,pmar[ip]);
		strcat(if_0_status[ip],sstmp);
	    }

	} else { /* inst. fetch cancelled. */

	    for (ip = 0 ; ip < NIP ; ip++) {
		/* return status */
		sprintf(if_0_status[ip],
			"instruction fetch cancelled.");
	    }

	}
	/* set internal ifcancel flag 'ifcancel1' */
	ifcancel1 = ifcancel;
	return ((char *)if_0_status);
}

char *ifetch1()
{
	int	ip;

	if (ifcancel1 == TRUE) {
		idcancel = TRUE;
		ifcancel = FALSE;
	} else {
		idcancel = FALSE;
		oldPC = PC;
	}

	for (ip = 0 ; ip < NIP ; ip++) {
	    /* select AddrALU input 1 */
	    switch (AALUin1_sel[ip]) {
		case AA1_SELECT_PC:
			addrALU_in1[ip] = PC;
			break;
		case AA1_SELECT_JBR:
			addrALU_in1[ip] = jump_basereg[ip];
			/* reset input selector to default */
			AALUin1_sel[ip] = AA1_SELECT_PC;
			break;
		default:
			break;
	    }
	    /* select AddrALU input 2 */
	    switch (AALUin2_sel[ip]) {
		case AA2_SELECT_NIP:
			addrALU_in2[ip] = NIP;
			break;
		case AA2_SELECT_DISP:
			addrALU_in2[ip] = jump_disp[ip];
			/* reset input selector to default */
			AALUin2_sel[ip] = AA2_SELECT_NIP;
			break;
		default:
			break;
	    }
	    /* AddrALU addition */
	    addrALU_out[ip] = addrALU_in1[ip] + addrALU_in2[ip];
	    /* return status */
	    sprintf(if_1_status[ip],
		    "Addr.ALU%1d:in1=0x%X, in2=0x%X, output=0x%X",
		    ip, addrALU_in1[ip], addrALU_in2[ip],
		    addrALU_out[ip]);
	}

	return ((char *)if_1_status);
}
