/* pipe-sim(+vector) ver.3.0 [92/05/28-7/29] */
/* 		     ver.3.2 [92/08/27-8/29] */
/* 		     ver.3.3 [92/09/03-9/10] */
/* 		     ver.3.4 [92/09/14] */
/* 		     ver.3.4a[92/09/16] */
/*                   ver.3.5a-R1.0 [93/10/25] */
/*					      */
/*                   ver.4.0 [94/5/30-06/15] */
/*                   ver.4.0a[94/6/16-06/] */
/*                   ver.4.3c[96/8/9] */
/* simulator initialize procedure */

#include "defines.h"
#include "latches.h"
#include "vectorls.h"
#include "cmnvar.h"
#include "opcode.h"
#include "extfunc.h"
#include "vpipectl.h"
#include "debugger.h"
#include "regdef.h"
#include "register_set.h"
#include "aalu.h"
#include "memwait.h"
#include "vectorcount.h"

static	char *nullstr = "";	/* empty string */

initial()
{
	int	i,j,ip;

	for (ip = 0 ; ip < NIP ; ip++) {
		ALUlatch[ip].address = 0;
		ALUlatch[ip].optype = NO_OPR;
		ALUlatch[ip].subtype1 = 0;
		ALUlatch[ip].subtype2 = 0;
		ALUlatch[ip].src1 = 0;
		ALUlatch[ip].src2 = 0;
		ALUlatch[ip].dstn = 0;

		alu_out[ip].regdst = FALSE;
		memlatch[ip] = ALUlatch[ip];

		wb_latch[ip].regdst = FALSE;
		wblatch[ip] = ALUlatch[ip];

		fwb_latch[ip].regdst = FALSE;
		fwblatch[ip] = ALUlatch[ip];

		loadaddr[ip] = 0;
		storeaddr[ip] = 0;

		loadflag[ip] = storeflag[ip] = FALSE;

		vluflag[ip] = vsuflag[ip] = VLSU_NOP;
		
		if_ss[ip] = id_ss[ip] = nullstr;
		alu_ss[ip] = mem_ss[ip] = nullstr;
		wb_ss[ip] = fwb_ss[ip] = nullstr;
		lu_ss[ip] = su_ss[ip] = nullstr;
		vlu_ss[ip] = vsu_ss[ip] = nullstr;
	}

	faspinit();
	for (i=0 ; i < NFASP ; i++) {
		faspcflag[i] = FASPC_NOP;
		fasp_in_ss[i] = nullstr;
#ifndef NOVECTOR
		faspctl_ss[i] = nullstr;
#endif
	}
		
	fmpinit();
	for (i=0 ; i < NFMP ; i++) {
		fmpcflag[i] = FMPC_NOP;
		fmp_in_ss[i] = nullstr;
#ifndef NOVECTOR
		fmpctl_ss[i] = nullstr;
#endif
	}
		
	fdpinit();
	for (i=0 ; i < NFDP ; i++) {
		fdpcflag[i] = FDPC_NOP;
		fdp_in_ss[i] = nullstr;
#ifndef NOVECTOR
		fdpctl_ss[i] = nullstr;
#endif
	}
		
#ifndef NOVECTOR
	vilpinit();
	for (i=0 ; i < NVILP ; i++) {
		vilpcflag[i] = VILPC_NOP;
		vilp_in_ss[i] = nullstr;
		vilpctl_ss[i] = nullstr;
	}
		
	cninit();
	for (i=0 ; i < NCN ; i++) {
		cn_in_ss[i] = nullstr;
		cn_out_ss[i] = nullstr;
	}
#endif

	clear_reg();
	/* for (i=0 ; i < REGSIZE ; i++) { */
	/* 	regfile[i].i = 0;	   */
	/* }				   */

	/* initialize program segment registers */
	/* initialized to not exist program segment */
	SPECIALREG(N_PSL).i = MEMSIZE;
	SPECIALREG(N_PSH).i = 0;

	for (i=0 ; i < VREGSIZE ; i++) {
		for (j=0 ; j < VREGLEN ; j++) {
			vectorreg[i][j].f = 0.0;
		}
	}

	for (i=0 ; i < VMRSIZE ; i++) {
		for (j=0 ; j < VREGLEN ; j++) {
			setVMR(i,j,TRUE);
		}
	}

	PC =  0;
	cycle = 0;

	for (ip = 0; ip < NIP ; ip++) {
	    jumploadpc[ip] = FALSE;
	    jumploadpc_id[ip] = FALSE;
	    jumploadpc_alu[ip] = FALSE;
	    addrALU_out[ip] = 0;
	}

	ifcancel = FALSE;
	idcancel = TRUE;

	/* clear memory wait cycles */
	totalmemwait = 0;
	clear_mem_wait();

#ifndef NOVECTOR
	/* clear vector count */
	clear_vectorcount();
#endif
}
