/* pipe-sim(+vector) ver.4.0 [94/05/30-06/15] */
/* 		     ver.4.0c[94/11/18] */
/* 		     ver.4.3 [94/12/26-95/01/20] */
/* 		     ver.4.3c[96/08/09] */
/* 		     ver.4.3e[96/09/20] */
/* 		     ver.4.3f[97/01/23,97/02/07] */
/* main procedure */

#define MAINPROGRAM

#include <stdio.h>
#include <signal.h>

#include "defines.h"
#include "latches.h"
#include "vectorls.h"
#include "cmnvar.h"
#include "vpipectl.h"
#include "opcode.h"
#include "display.h"
#include "debugger.h"
#include "aalu.h"
#include "memwait.h"
#include "vectorcount.h"

main(argc,argv)
int	argc;
char	*argv[];
{
	int	start,end;
	int	endstate;
	extern	int write_collision;
	char	ans[10];
	int	i;

	batchmode = FALSE;
	memwaitmode = MEM_WAIT_MAX;

	switch (argc) {
	    case 2:
		strcpy(objfile,argv[1]);
		break;
	    case 3:
		if (argv[1][1] == 'b') {
		    batchmode = TRUE;
		} else {
		    usage(argv[0]);
		    exit(1);
		}
		strcpy(objfile,argv[2]);
		break;
	    default:
		usage(argv[0]);
		exit(1);
	}

	if (!isatty(1)) {	/* if stdout is redirected to file */
	    batchmode = TRUE;	/* set batchmode flag true. */
	}

	if (batchmode == FALSE) {
	    dispinit();

	    signal(SIGINT,interrupt);

	    debugger_main();

	    dispfinish();

	    signal(SIGINT,SIG_DFL);
	} else {
	    initial();
	    clearbreakpoint();	/* clear breakpoint */
	    clearbreakcycle();	/* clear breakcycle */
	    progload(objfile);
	    if (simulate() == HALT_END) {
		printf ("cycle = %d(+memwait %d); write_collision = %d\n",
			cycle,totalmemwait,write_collision);
#ifndef NOVECTOR
		for (i = 0 ; i < NFASP ; i++) {
		    printf ("No.%1d vector add/sub cycle  = %d\n",
			    i,faspusedcount[i]);
		}
		printf ("total vector add/sub cycle = %d\n",
			fasptotalusedcount);

		for (i = 0 ; i < NFMP ; i++) {
		    printf ("No.%1d vector mult. cycle    = %d\n",
			    i,fmpusedcount[i]);
		}
		printf ("total vector mult. cycle   = %d\n",
			fmptotalusedcount);

		for (i = 0 ; i < NFDP ; i++) {
		    printf ("No.%1d vector div. cycle     = %d\n",
			    i,fdpusedcount[i]);
		}
		printf ("total vector div. cycle    = %d\n",
			fdptotalusedcount);

		for (i = 0 ; i < NVILP ; i++) {
		    printf ("No.%1d vector integer cycle  = %d\n",
			    i,vilpusedcount[i]);
		}
		printf ("total vector integer cycle = %d\n",
			vilptotalusedcount);

		for (i = 0 ; i < NIP ; i++) {
		    printf ("No.%1d vector load cycle     = %d\n",
			    i,vloadusedcount[i]);
		}
		printf ("total vector load cycle    = %d\n",
			vloadtotalusedcount);

		for (i = 0 ; i < NIP ; i++) {
		    printf ("No.%1d vector store cycle    = %d\n",
			    i,vstoreusedcount[i]);
		}
		printf ("total vector store cycle   = %d\n",
			vstoretotalusedcount);

		printf ("total vector unit cycle    = %d\n",
			vectortotalusedcount);
#endif
	    } else {
		printf ("ERROR STOP at cycle = %d; PC = 0x%08X\n",cycle,PC);
	    }
	}

	exit(0);
}

usage(progname)	/* usage print out */
char	*progname;
{
	fprintf(stderr,"usage:	%s [-b] objectfilename\n",progname);
}
