/***
 ***    ps4v ver.4.3c	   [96/Aug/09] by kata.
 ***    ps4v ver.4.3d	   [96/Aug/12] by kata.
 ***
 ***    counting memory waits.
 ***
 ***/

#include <stdio.h>
#include <stdlib.h>
#include "defines.h"
#include "memwait.h"

static char errstr[100]; /* error message temp. */

memwait()
{
	int ip;
	int waitcycle = 0;
	int max_wait = 0;

	if (memwaitmode == MEM_WAIT_SUM) { 
	    /* total mem wait of each cycle = 
		    sum of each IP's waits */

	    for (ip = 0 ; ip < NIP ; ip++) {
		waitcycle += readmemwait[ip];
		waitcycle += writememwait[ip];
#ifndef NOVECTOR
		waitcycle += v_readmemwait[ip];
		waitcycle += v_writememwait[ip];
#endif
	    }

	    totalmemwait += waitcycle;

	} else if (memwaitmode == MEM_WAIT_MAX) {
	    /* total mem wait of each cycle = 
		    max of each IP's waits */

	    for (ip = 0 ; ip < NIP ; ip++) {
		if (readmemwait[ip] > max_wait) {
		    max_wait += readmemwait[ip];
		}
		if (writememwait[ip] > max_wait) {
		    max_wait += writememwait[ip];
		}
#ifndef NOVECTOR
		if (v_readmemwait[ip] > max_wait) {
		    max_wait += v_readmemwait[ip];
		}
		if (v_writememwait[ip] > max_wait) {
		    max_wait += v_writememwait[ip];
		}
#endif
	    }

	    totalmemwait += max_wait;

	}

	clear_mem_wait() ;

}

clear_mem_wait()
{
	int ip;

	for (ip = 0 ; ip < NIP ; ip++) {
	    readmemwait[ip] = 0;
	    writememwait[ip] = 0;
#ifndef NOVECTOR
	    v_readmemwait[ip] = 0;
	    v_writememwait[ip] = 0;
#endif
	}
}
