/* pipe-sim(+vector) ver.3.0 [92/05/28-7/29] */
/* pipe-sim(+vector) ver.4.0 [94/05/30-6/15] */
/* define vector mnemonics */

/* vector mnemonic defines */

/* vector load/store */

/* vector load,increment is register */
#define VLIR(dstn,base,incr,vmr)	(VECTOR<<29)|(V_LS<<27)|(VOP_LDIR<<25)|(((vmr)&0x7)<<22)|(((dstn)&0x3f)<<16)|(((base)&0xff)<<8)|((incr)&0xff)
/* vector load,increment is immed. */
#define VLII(dstn,base,incr,vmr)	(VECTOR<<29)|(V_LS<<27)|(VOP_LDII<<25)|(((vmr)&0x7)<<22)|(((dstn)&0x3f)<<16)|(((base)&0xff)<<8)|((incr)&0xff)

/* vector store,increment is register */
#define VSIR(dstn,base,incr,vmr)	(VECTOR<<29)|(V_LS<<27)|(VOP_STIR<<25)|(((vmr)&0x7)<<22)|(((dstn)&0x3f)<<16)|(((base)&0xff)<<8)|((incr)&0xff)
/* vector store,increment is immed. */
#define VSII(dstn,base,incr,vmr)	(VECTOR<<29)|(V_LS<<27)|(VOP_STII<<25)|(((vmr)&0x7)<<22)|(((dstn)&0x3f)<<16)|(((base)&0xff)<<8)|((incr)&0xff)

/* vector calc. operation */

/* floating operation */
#define VFADD(src1,src2,dstn,vmr)	(VECTOR<<29)|(V_CALC<<27)|(VOP_FADD<<22)|(((vmr)&0x7)<<19)|(((src1)&0x3f)<<12)|(((src2)&0x3f)<<6)|((dstn)&0x3f)
#define VFSUB(src1,src2,dstn,vmr)	(VECTOR<<29)|(V_CALC<<27)|(VOP_FSUB<<22)|(((vmr)&0x7)<<19)|(((src1)&0x3f)<<12)|(((src2)&0x3f)<<6)|((dstn)&0x3f)
#define VFMUL(src1,src2,dstn,vmr)	(VECTOR<<29)|(V_CALC<<27)|(VOP_FMULT<<22)|(((vmr)&0x7)<<19)|(((src1)&0x3f)<<12)|(((src2)&0x3f)<<6)|((dstn)&0x3f)
#define VFDIV(src1,src2,dstn,vmr)	(VECTOR<<29)|(V_CALC<<27)|(VOP_FDIV<<22)|(((vmr)&0x7)<<19)|(((src1)&0x3f)<<12)|(((src2)&0x3f)<<6)|((dstn)&0x3f)
/* integer operation */
#define VADD(src1,src2,dstn,vmr)	(VECTOR<<29)|(V_CALC<<27)|(VOP_IADD<<22)|(((vmr)&0x7)<<19)|(((src1)&0x3f)<<12)|(((src2)&0x3f)<<6)|((dstn)&0x3f)
#define VSUB(src1,src2,dstn,vmr)	(VECTOR<<29)|(V_CALC<<27)|(VOP_ISUB<<22)|(((vmr)&0x7)<<19)|(((src1)&0x3f)<<12)|(((src2)&0x3f)<<6)|((dstn)&0x3f)
#define VMUL(src1,src2,dstn,vmr)	(VECTOR<<29)|(V_CALC<<27)|(VOP_IMULT<<22)|(((vmr)&0x7)<<19)|(((src1)&0x3f)<<12)|(((src2)&0x3f)<<6)|((dstn)&0x3f)
#define VDIV(src1,src2,dstn,vmr)	(VECTOR<<29)|(V_CALC<<27)|(VOP_IDIV<<22)|(((vmr)&0x7)<<19)|(((src1)&0x3f)<<12)|(((src2)&0x3f)<<6)|((dstn)&0x3f)
/* logical operation */
#define VAND(src1,src2,dstn,vmr)	(VECTOR<<29)|(V_CALC<<27)|(VOP_LAND<<22)|(((vmr)&0x7)<<19)|(((src1)&0x3f)<<12)|(((src2)&0x3f)<<6)|((dstn)&0x3f)
#define VOR(src1,src2,dstn,vmr)	(VECTOR<<29)|(V_CALC<<27)|(VOP_LOR<<22)|(((vmr)&0x7)<<19)|(((src1)&0x3f)<<12)|(((src2)&0x3f)<<6)|((dstn)&0x3f)
#define VXOR(src1,src2,dstn,vmr)	(VECTOR<<29)|(V_CALC<<27)|(VOP_LXOR<<22)|(((vmr)&0x7)<<19)|(((src1)&0x3f)<<12)|(((src2)&0x3f)<<6)|((dstn)&0x3f)
#define VNOT(src1,dstn,vmr)	(VECTOR<<29)|(V_CALC<<27)|(VOP_LNOT<<22)|(((vmr)&0x7)<<19)|(((src1)&0x3f)<<12)|((dstn)&0x3f)
/* scalar & vector mixed operation */
#define VBCAST(src_s,dstn,vmr)	(VECTOR<<29)|(V_CALC<<27)|(VOP_BCAST<<22)|(((vmr)&0x7)<<19)|(((src_s)&0x7f)<<12)|((dstn)&0x3f)
#define VSRL(src_s,src_v,dstn,vmr)	(VECTOR<<29)|(V_CALC<<27)|(VOP_VSRL<<22)|(((vmr)&0x7)<<19)|(((src_s)&0x7f)<<12)|(((src_v)&0x3f)<<6)|((dstn)&0x3f)
#define VSLL(src_s,src_v,dstn,vmr)	(VECTOR<<29)|(V_CALC<<27)|(VOP_VSLL<<22)|(((vmr)&0x7)<<19)|(((src_s)&0x7f)<<12)|(((src_v)&0x3f)<<6)|((dstn)&0x3f)

/* vector misc. instructions */

/* vector mask reg. operation */
#define VMRAND(src1,src2,dstn)	(VECTOR<<29)|(V_MISC<<27)|(VOP_VMROP<<23)|(MOP_AND<<9)|(((src1)&0x7)<<6)|(((src2)&0x7)<<3)|((dstn)&0x7)
#define VMROR(src1,src2,dstn)	(VECTOR<<29)|(V_MISC<<27)|(VOP_VMROP<<23)|(MOP_OR<<9)|(((src1)&0x7)<<6)|(((src2)&0x7)<<3)|((dstn)&0x7)
#define VMRXOR(src1,src2,dstn)	(VECTOR<<29)|(V_MISC<<27)|(VOP_VMROP<<23)|(MOP_XOR<<9)|(((src1)&0x7)<<6)|(((src2)&0x7)<<3)|((dstn)&0x7)
#define VMRNOT(src1,dstn)	(VECTOR<<29)|(V_MISC<<27)|(VOP_VMROP<<23)|(MOP_NOT<<9)|(((src1)&0x7)<<6)|((dstn)&0x7)

/* vector mask reg. set */
#define VMRSET(cond,src,dstn)	(VECTOR<<29)|(V_MISC<<27)|(VOP_VMRSET<<23)|(((cond)&0xf)<<9)|(((src)&0x3f)<<3)|((dstn)&0x7)

/* list vector load/store */
/* list vector load */
#define LVLD(listv,dstn,vmr)	(VECTOR<<29)|(V_MISC<<27)|(VOP_LVLS<<23)|(((vmr)&0x7)<<13)|(((listv)&0x3f)<<6)|((dstn)&0x3f)
/* list vector store */
#define LVST(listv,dstn,vmr)	(VECTOR<<29)|(V_MISC<<27)|(VOP_LVLS<<23)|(((vmr)&0x7)<<13)|(1<<12)|(((listv)&0x3f)<<6)|((dstn)&0x3f)
/* list vector load,based addressing */
#define LVBLD(listv,dstn,base)	(VECTOR<<29)|(V_MISC<<27)|(VOP_LVBLS<<23)|(((base)&0xff)<<13)|(((listv)&0x3f)<<6)|((dstn)&0x3f)
/* list vector store,based addressing */
#define LVBST(listv,dstn,base)	(VECTOR<<29)|(V_MISC<<27)|(VOP_LVBLS<<23)|(((base)&0xff)<<13)|(1<<12)|(((listv)&0x3f)<<6)|((dstn)&0x3f)

/* vector int to float conversion */
#define VFLT(src,dstn,vmr)	(VECTOR<<29)|(V_MISC<<27)|(VOP_CONV<<23)|(((vmr)&0x7)<<13)|(((src)&0x3f)<<6)|((dstn)&0x3f)
/* vector float to int conversion */
#define VINT(src,dstn,vmr)	(VECTOR<<29)|(V_MISC<<27)|(VOP_CONV<<23)|(((vmr)&0x7)<<13)|(1<<12)|(((src)&0x3f)<<6)|((dstn)&0x3f)

/* move scalar reg. to vector reg. */
#define MOVVS(vreg,pos,sreg)	(VECTOR<<29)|(V_MISC<<27)|(VOP_MOVEV2S<<23)|(((vreg)&0x3f)<<16)|(((pos)&0xff)<<8)|((sreg)&0xff)
/* move vector reg. to scalar reg. */
#define MOVSV(src,dstn,sreg)	(VECTOR<<29)|(V_MISC<<27)|(VOP_MOVES2V<<23)|(((vreg)&0x3f)<<16)|(((pos)&0xff)<<8)|((sreg)&0xff)
