/* pipe-sim(+vector) ver.3.0 [92/05/28-7/29] */
/* pipe-sim(+vector) ver.4.0 [94/05/30-06/15] */
/* opcode -> opcode_strings conversion tables */

#include "global.h"

/* opcode strings conv. table */

/* instruction type */

static char *optype_s[]={"LOAD","STORE","INTCALC","FLOATCALC","JUMP","COMPJUMP","VECTOR"};

/* LOAD/STORE instruction addressing mode */

static char *addrmode_s[]={"IMMEDIATE","DIRECT","BASED","BASE&INDXED","BASE-SIFTED","PCBASED","PCBINDXED"};

/* ALU operand immediate flag */

static char *immedflag_s[]={"REG","IMMED"};

/* ALU operation */

static char *aluop_s[]={"ADD","SUB","MUL","DIV","MOD","RSUB","UMUL","UDIV","AND","OR","XOR","NOT","SRL","SLL","SRA","SLA"};

/* float operation */

static char *fop_s[]={"FADD","FSUB","FMLT","FDIV","(undefined)","(undefined)","(undefined)","(undefined)","FCONVINT","FCONVFLT"};

/* jump addressing mode */

static char *jumpaddr_s[]={"RELATIVE","BASED","RELATIVE&LINK","BASED&LINK"};

/* jump conditions */

static char *jumpcond_s[]={"ALWAYS","PLUS","MINUS","ZERO","NOTPLUS","NOTMINUS","NOTZERO"};

/* compare&jump conditions */

static char *cjcond_s[]={"PLUS","MINUS","ZERO","NONZERO"};

/* compare&jump operations */

static char *cjop_s[]={"SUB","RSUB","AND","OR","IMMED_SUB","IMMED_RSUB","IMMED_AND","IMMED_OR"};

/* vector operation */

static char *vop_s[]={"V_CALC","V_LS","V_MISC"};

/* vector calc operations */
/* floating operation */
static char *vcalcop_s[]={"FADD","FSUB","FMULT","FDIV","IADD","ISUB","IMULT","IDIV","LAND","LOR","LXOR","LNOT","BROADCAST","(undefined)","VSRL","VSLL"};

/* vector load/store & list vector load/store */
/* vector load/store = addressing mode is based-autoincrement only. */
/* increment value is in scalar reg or immediate constant. */
/* list vector load/store = addr. mode is indexed or base-indexed */

static char *vlsop_s[]={"LD-Inc=Reg.","LD-Inc=Immed","ST-Inc=Reg.","ST-Inc=Immed","LVLD","LVBasedLD","LVST","LVBasedST"};

/* vector misc instructions */

static char *vmisc_s[]={"VMROP","VMRSET","LVLS","LVLS(BASED)","V-CONV","(undefined)","MOVES2V","MOVEV2S"};

/* vector mask reg.(VMR) instructions */
/* VMR operations */

static char *vmrop_s[]={"AND","OR","XOR","NOT"};

/* VMR set conditions */

static char *vmrsetcond_s[]={"F_ZERO","F_NOTZERO","F_PLUS","F_NOTPLUS","F_MINUS","F_NOTMINUS","(undefined)","(undefined)","I_ZERO","I_NOTZERO","I_PLUS","I_NOTPLUS","I_MINUS","I_NOTMINUS","(undefined)","(undefined)"};

/* vectore reg. float/int conversion */

static char *vconv_s[]={"CONVI2F","CONVF2I"};
