/* pipe-sim(+vector) ver.3.0 [92/05/28-7/29] */
/*                   ver.3.1 [92/08/26] */
/*                   ver.3.4 [92/09/14] */
/*                   ver.3.5 [92/12/14] */
/*					    */
/* pipe-sim(+vector) ver.4.0 [94/05/30-6/15] */
/* 		     ver.4.0c[94/11/18] */
/* object program loader */

#include <stdio.h>

#include "defines.h"
#include "latches.h"
#include "cmnvar.h"
#include "opcode.h"
#include "display.h"
#include "debugger.h"

int progload(filename)
char	*filename;
{
	FILE	*objfile;
	int	addr;
	char	loadfile[256];
	char	linebuff[256];

	addr = 0 ;	/* default program start addr = 0 */

	if (strcmp(filename+strlen(filename)-4,".obj")==0) {
		strcpy(loadfile,filename);
	} else { /* no filename extention '.obj' */
		strcpy(loadfile,filename);
		strcat(loadfile,".obj");/* append extention */
	}

	if ((objfile = fopen(loadfile,"r")) == NULL) {
	    if (batchmode == FALSE) {	/* debugger mode */
		mvprintw (COMMANDLINE+2,0,"%s not found.",loadfile);
		dispflush();
		return(FALSE);
	    } else {			/* batch mode */
		fprintf (stderr,"%s not found.\n",loadfile);
		exit(1);
	    }
	}

	if (batchmode == FALSE) {
		mvprintw(COMMANDLINE+2,0,"Loading... ");
		dispflush();
	}

	while(fgets(linebuff,256,objfile) != NULL) {
		if (linebuff[0] == ':') { /* address */
			sscanf(linebuff,":%x",&addr);
#ifdef DEBUG
			fprintf (stderr,"progload: addr = %08X\n",addr);
#else
			if (batchmode == FALSE) {
			    printw("%08X ",addr);
			    dispflush();
			}
#endif
		} else { /* object code */
			sscanf(linebuff,"%x",&memory[addr].i);
#ifdef DEBUG
			fprintf (stderr,"progload: memory[%08X] = %08X\n",addr,memory[addr].i);
#endif
			addr++;
		}
	}

	fclose(objfile);

#ifdef DEBUG
	gets(linebuff);	/* wait for return key input */
#else
	if (batchmode == FALSE) {
	    printw(stderr,"done.");
	    dispflush();
	}
#endif

	return (TRUE);
}
