/* pipe-sim(+vector) ver.3.0 [92/05/28-7/29] */
/* 		     ver.3.4 [92/09/14] */
/* pipe-sim(+vector) ver.4.3 [94/12/26-95/01/20] */
/*                   ver.4.3e[96/09/20] */
/* vector load unit */

#include "defines.h"
#include "latches.h"
#include "vectorls.h"
#include "vpipectl.h"
#include "cmnvar.h"
#include "opcode.h"
#include "vectorcount.h"

void clear_vectorcount()
{
	int i;

	for (i = 0 ; i < NFASP ; i++) {
	faspusedcount[i] = 0;
	}
	fasptotalusedcount = 0;

	for (i = 0 ; i < NFMP ; i++) {
	fmpusedcount[i] = 0;
	}
	fmptotalusedcount = 0;

	for (i = 0 ; i < NFDP ; i++) {
	fdpusedcount[i] = 0;
	}
	fdptotalusedcount = 0;

	for (i = 0 ; i < NVILP ; i++) {
	vilpusedcount[i] = 0;
	}
	vilptotalusedcount = 0;

	for (i = 0 ; i < NIP ; i++) {
	vloadusedcount[i] = 0;
	}
	vloadtotalusedcount = 0;

	for (i = 0 ; i < NIP ; i++) {
	vstoreusedcount[i] = 0;
	}
	vstoretotalusedcount = 0;

	vectortotalusedcount = 0;
}

void vectorcount()
{
	int i;
	int faspused,fmpused,fdpused,vilpused;
	int vloadused,vstoreused,vectorused;

	/* initialize used flags to false */
	faspused = FALSE;
	fmpused = FALSE;
	fdpused = FALSE;
	vilpused = FALSE;
	vloadused = FALSE;
	vstoreused = FALSE;
	vectorused = FALSE;

	/* check vector add/sub unit */
	for (i = 0 ; i < NFASP ; i++) {
	    if (faspcflag[i] == FASPC_RUN) {
		faspusedcount[i]++;
		faspused = TRUE;
		vectorused = TRUE;
	    }
	}
	if (faspused == TRUE) fasptotalusedcount++;

	/* check vector mult unit */
	for (i = 0 ; i < NFMP ; i++) {
	    if (fmpcflag[i] == FMPC_RUN) {
		fmpusedcount[i]++;
		fmpused = TRUE;
		vectorused = TRUE;
	    }
	}
	if (fmpused == TRUE) fmptotalusedcount++;

	/* check vector div unit */
	for (i = 0 ; i < NFDP ; i++) {
	    if (fdpcflag[i] == FDPC_RUN) {
		fdpusedcount[i]++;
		fdpused = TRUE;
		vectorused = TRUE;
	    }
	}
	if (fdpused == TRUE) fdptotalusedcount++;

	/* check vector int/logic unit */
	for (i = 0 ; i < NVILP ; i++) {
	    if (vilpcflag[i] == VILPC_RUN) {
		vilpusedcount[i]++;
		vilpused = TRUE;
		vectorused = TRUE;
	    }
	}
	if (vilpused == TRUE) vilptotalusedcount++;

	/* check vector load unit */
	for (i = 0 ; i < NIP ; i++) {
	    if (vluflag[i] == VLSU_RUN) {
		vloadusedcount[i]++;
		vloadused = TRUE;
		vectorused = TRUE;
	    }
	}
	if (vloadused == TRUE) vloadtotalusedcount++;

	/* check vector store unit */
	for (i = 0 ; i < NIP ; i++) {
	    if (vsuflag[i] == VLSU_RUN) {
		vstoreusedcount[i]++;
		vstoreused = TRUE;
		vectorused = TRUE;
	    }
	}
	if (vstoreused == TRUE) vstoretotalusedcount++;

	if (vectorused == TRUE) vectortotalusedcount++;
}
