/* pipe-sim(+vector) ver.3.0 [92/05/28-7/29] */
/* 		     ver.3.4 [92/09/14] */
/* pipe-sim(+vector) ver.4.3 [94/12/26-95/01/20] */
/*                   ver.4.3c[96/08/12] */
/* vector load unit */

#include "defines.h"
#include "latches.h"
#include "vectorls.h"
#include "cmnvar.h"
#include "opcode.h"
#include "memwait.h"

static int vlu_inst[NIP],vlu_incr[NIP],vlu_base[NIP],vlu_dstn[NIP];
static int vlu_vmr[NIP],vlu_lstv[NIP];
static int vlu_vectorlength[NIP];
static int loadloop[NIP];

static char vlu0_status[NIP][SSLEN];
static char vlu1_status[NIP][SSLEN];

char *vlu0(ip)
int	ip;
{
	int	memaddr;
	char	vlu0tmp[40];

	switch(vluflag[ip]) {
            case VLSU_NOP: /* no operation */
                strcpy(vlu0_status[ip],"no operation");
                break;
	    case VLSU_ADDRSET: /* load addr set to vlu */
		switch(vloadinst[ip]) {
		    case VOP_LDIR:
		    case VOP_LDII:
			vlu_inst[ip] = vloadinst[ip];
			vlu_incr[ip] = vloadincr[ip];
			vlu_base[ip] = vloadbase[ip];
			vlu_dstn[ip] = vloaddstn[ip];
			vlu_vmr[ip] = vloadvmr[ip];
			vlu_vectorlength[ip] = SPECIALREG(N_VLCR+ip).i;

			/*
                         * λǥѥ᡼Ѥ
			 * ١ɥ쥹:vlu_base
			 * ʬ          :vlu_incr
			 * ٥ȥĹ    :vlu_vectorlength
			 * Ԥʸmemwait
			*/
			v_readmemwait[ip] += 0;

			loadloop[ip] = 0;
			memaddr = vlu_base[ip];
			if ((memaddr < 0)||(memaddr >= MEMSIZE)) {
			    /* irregal addr. access */
			    error("bus error",
				  "vector load unit phase 0",ip);
			} else {
			    if (VMR(vlu_vmr[ip],loadloop[ip])==TRUE) {
				vectorreg[vlu_dstn[ip]][loadloop[ip]] = memory[memaddr];
			    }
			}

			sprintf(vlu0_status[ip],
			    "VLD addr-set(baseaddr=0x%X,increment=%d);memory[0x%X]->VR%d[%d]",
			    vlu_base[ip],vlu_incr[ip],memaddr,
			    vlu_dstn[ip],loadloop[ip]);
			if (vlu_vmr[ip] == 0) {
			    sprintf(vlu0tmp,":VMR not used.");
			} else {
			    sprintf(vlu0tmp,":VMR%d[%d]=%s",
			    vlu_vmr[ip],loadloop[ip],
			    (VMR(vlu_vmr[ip],loadloop[ip])==TRUE)?"TRUE":"FALSE");
			}
			strcat(vlu0_status[ip],vlu0tmp);

			/* decrement Vector Load Count Reg. */
			SPECIALREG(N_VLCR+ip).i--;

			loadloop[ip]++;
			vluflag[ip] = VLSU_RUN;
			break;
		    case VOP_LVLD:
		    case VOP_LVBLD:
		        vlu_inst[ip] = vloadinst[ip];
			vlu_lstv[ip] = vloadlstv[ip];
			vlu_base[ip] = vloadbase[ip];
			vlu_dstn[ip] = vloaddstn[ip];
			vlu_vmr[ip] = vloadvmr[ip];
			vlu_vectorlength[ip] = SPECIALREG(N_VLCR+ip).i;
			loadloop[ip] = 0;
			memaddr = vlu_base[ip]+vectorreg[vlu_lstv[ip]][loadloop[ip]].i;
			if (VMR(vlu_vmr[ip],loadloop[ip])==TRUE) {
			    if ((memaddr < 0)||(memaddr >= MEMSIZE)) {
				/* irregal addr. access */
				error("bus error",
				      "vector load unit phase 0",ip);
			    } else {
				vectorreg[vlu_dstn[ip]][loadloop[ip]] = memory[memaddr];
			    }
			}

			sprintf(vlu0_status[ip],
			    "LVLD addr-set(baseaddr=0x%X,listVR=%d);memory[0x%X]->VR%d[%d]",
			    vlu_base[ip],vlu_lstv[ip],memaddr,
			    vlu_dstn[ip],loadloop[ip]);
			if (vlu_vmr[ip] == 0) {
			    sprintf(vlu0tmp,":VMR not used.");
			} else {
			    sprintf(vlu0tmp,":VMR%d[%d]=%s",
			    vlu_vmr[ip],loadloop[ip],
			    (VMR(vlu_vmr[ip],loadloop[ip])==TRUE)?"TRUE":"FALSE");
			}
			strcat(vlu0_status[ip],vlu0tmp);

			/* decrement Vector Load Count Reg. */
			SPECIALREG(N_VLCR+ip).i--;

			loadloop[ip]++;
			vluflag[ip] = VLSU_RUN;
			break;
		}
		break;	/* end of case VLSU_ADDRSET */
	    case VLSU_RUN:  /* vlu is running */
		switch(vlu_inst[ip]) {
		    case VOP_LDIR:
		    case VOP_LDII:
			memaddr = vlu_base[ip] + vlu_incr[ip] * loadloop[ip];
			if (VMR(vlu_vmr[ip],loadloop[ip])==TRUE) {
			    if ((memaddr < 0)||(memaddr >= MEMSIZE)) {
				/* irregal addr. access */
				error("bus error",
				      "vector load unit phase 0",ip);
			    } else {
				vectorreg[vlu_dstn[ip]][loadloop[ip]] = memory[memaddr];
			    }
			}

			sprintf(vlu0_status[ip],
			    "VLD running ; memory[0x%X]->VR%d[%d]",
			    memaddr,vlu_dstn[ip],loadloop[ip]);
			if (vlu_vmr[ip] == 0) {
			    sprintf(vlu0tmp,":VMR not used.");
			} else {
			    sprintf(vlu0tmp,":VMR%d[%d]=%s",
			    vlu_vmr[ip],loadloop[ip],
			    (VMR(vlu_vmr[ip],loadloop[ip])==TRUE)?"TRUE":"FALSE");
			}
			strcat(vlu0_status[ip],vlu0tmp);

			/* decrement Vector Load Count Reg. */
			SPECIALREG(N_VLCR+ip).i--;

			if (++loadloop[ip]==vlu_vectorlength[ip]) vluflag[ip] = VLSU_NOP;
			break;
		    case VOP_LVLD:
		    case VOP_LVBLD:
			memaddr = vlu_base[ip]+vectorreg[vlu_lstv[ip]][loadloop[ip]].i;
			if (VMR(vlu_vmr[ip],loadloop[ip])==TRUE) {
			    if ((memaddr < 0)||(memaddr >= MEMSIZE)) {
				/* irregal addr. access */
				error("bus error",
				      "vector load unit phase 0",ip);
			    } else {
				vectorreg[vlu_dstn[ip]][loadloop[ip]] = memory[memaddr];
			    }
			}

			sprintf(vlu0_status[ip],
			    "LVLD running ; memory[0x%X]->VR%d[%d]",
			    memaddr,vlu_dstn[ip],loadloop[ip]);
			if (vlu_vmr[ip] == 0) {
			    sprintf(vlu0tmp,":VMR not used.");
			} else {
			    sprintf(vlu0tmp,":VMR%d[%d]=%s",
			    vlu_vmr[ip],loadloop[ip],
			    (VMR(vlu_vmr[ip],loadloop[ip])==TRUE)?"TRUE":"FALSE");
			}
			strcat(vlu0_status[ip],vlu0tmp);

			/* decrement Vector Load Count Reg. */
			SPECIALREG(N_VLCR+ip).i--;

			if (++loadloop[ip]==vlu_vectorlength[ip]) vluflag[ip] = VLSU_NOP;
			break;
		}
		break;	/* end of case VLSU_RUN */
	} /* end of switch(vluflag[ip]) */
	
	/* return status */
	return(vlu0_status[ip]);
}

char *vlu1(ip)
int	ip;
{
	int	memaddr;
	char	vlu1tmp[40];

	switch(vluflag[ip]) {
            case VLSU_NOP: /* no operation */
                strcpy(vlu1_status[ip],"no operation");
                break;
	    case VLSU_RUN:  /* vlu is running */
		switch(vlu_inst[ip]) {
		    case VOP_LDIR:
		    case VOP_LDII:
			sprintf(vlu1_status[ip],"VLD running ;");
			break;
		    case VOP_LVLD:
		    case VOP_LVBLD:
			sprintf(vlu1_status[ip],"LVLD running ;");
			break;
		}
		break;	/* end of case VLSU_RUN */
	} /* end of switch(vluflag[ip]) */
	
	/* return status */
	return(vlu1_status[ip]);
}

/* following codes are not used. */
#define NOTUSED
#ifndef NOTUSED
char *vlu1(ip)
int	ip;
{
	int	memaddr;
	char	vlu1tmp[40];

	switch(vluflag[ip]) {
            case VLSU_NOP: /* no operation */
                strcpy(vlu1_status[ip],"no operation");
                break;
	    case VLSU_RUN:  /* vlu is running */
		switch(vlu_inst[ip]) {
		    case VOP_LDIR:
		    case VOP_LDII:
			memaddr = vlu_base[ip] + vlu_incr[ip] * loadloop[ip];
			if (VMR(vlu_vmr[ip],loadloop[ip])==TRUE) {
			    if ((memaddr < 0)||(memaddr >= MEMSIZE)) {
				/* irregal addr. access */
				error("bus error",
				      "vector load unit phase 1",ip);
			    } else {
				vectorreg[vlu_dstn[ip]][loadloop[ip]] = memory[memaddr];
			    }
			}

			sprintf(vlu1_status[ip],
			    "VLD running ; memory[0x%X]->VR%d[%d]",
			    memaddr,vlu_dstn[ip],loadloop[ip]);
			if (vlu_vmr[ip] == 0) {
			    sprintf(vlu1tmp,":VMR not used.");
			} else {
			    sprintf(vlu1tmp,":VMR%d[%d]=%s",
			    vlu_vmr[ip],loadloop[ip],
			    (VMR(vlu_vmr[ip],loadloop[ip])==TRUE)?"TRUE":"FALSE");
			}
			strcat(vlu1_status[ip],vlu1tmp);

			if (++loadloop[ip]==vlu_vectorlength[ip]) vluflag[ip] = VLSU_NOP;
			break;
		    case VOP_LVLD:
		    case VOP_LVBLD:
			memaddr = vlu_base[ip]+vectorreg[vlu_lstv[ip]][loadloop[ip]].i;
			if (VMR(vlu_vmr[ip],loadloop[ip])==TRUE) {
			    if ((memaddr < 0)||(memaddr >= MEMSIZE)) {
				/* irregal addr. access */
				error("bus error",
				      "vector load unit phase 1",ip);
			    } else {
				vectorreg[vlu_dstn[ip]][loadloop[ip]] = memory[memaddr];
			    }
			}

			sprintf(vlu1_status[ip],
			    "LVLD running ; memory[0x%X]->VR%d[%d]",
			    memaddr,vlu_dstn[ip],loadloop[ip]);
			if (vlu_vmr[ip] == 0) {
			    sprintf(vlu1tmp,":VMR not used.");
			} else {
			    sprintf(vlu1tmp,":VMR%d[%d]=%s",
			    vlu_vmr[ip],loadloop[ip],
			    (VMR(vlu_vmr[ip],loadloop[ip])==TRUE)?"TRUE":"FALSE");
			}
			strcat(vlu1_status[ip],vlu1tmp);

			if (++loadloop[ip]==vlu_vectorlength[ip]) vluflag[ip] = VLSU_NOP;
			break;
		}
		break;	/* end of case VLSU_RUN */
	} /* end of switch(vluflag[ip]) */
	
	/* return status */
	return(vlu1_status[ip]);
}
#endif
