/* pipe-sim(+vector) ver.3.0 [92/05/28-7/29] */
/* pipe-sim(+vector) ver.4.3 [94/12/26-95/01/20] */
/* status generator for vpipe-controlers (for fasp,fmdp,vilp) */

#include "defines.h"
#include "latches.h"
#include "vectorls.h"
#include "cmnvar.h"
#include "vpipectl.h"
#include "opcode.h"
#include "opstr.h"

char faspc_ss[SSLEN];
char fmpc_ss[SSLEN];
char fdpc_ss[SSLEN];
char vilpc_ss[SSLEN];

/* make status of fasp-controler */
char *faspc_state(fp,pipeop,src1,src2,dstn,chain,vmr,loop)
int fp;		/* No. of floating add/sub pipe */
int pipeop;	/* opcode for pipeline */
int src1,src2;	/* source operands */
int dstn;	/* destination operand */
int chain;	/* chaining flag */
int vmr;	/* vector mask reg. */
int loop;	/* loop count for vector reg. access */
{
	char opchar;
	char fstmp[40];

	switch (pipeop) {
		case FOP_ADD:
		    opchar = '+';
		    break;
		case FOP_SUB:
		    opchar = '-';
		    break;
	}
	if (loop < FASPLEN) { /* send to fasp only */
	    switch (chain) {
		case CHAIN_OFF:
		    sprintf(faspc_ss,
			    "VR%d[%d]%cVR%d[%d]->[floating add/sub pipe%d]",
			    src2,loop,opchar,src1,loop,fp);
		    break;
		case CHAIN_RRC:
		    sprintf(faspc_ss,
			    "VR%d[%d]%cVR%d[%d]->[floating add/sub pipe%d]",
			    src2,loop,opchar,src1,loop,fp);
		    break;
		case CHAIN_RCR:
		    sprintf(faspc_ss,
			    "CN%d%cVR%d[%d]->[floating add/sub pipe%d]",
			    src2,opchar,src1,loop,fp);
		    break;
		case CHAIN_RCC:
		    sprintf(faspc_ss,
			    "CN%d%cVR%d[%d]->[floating add/sub pipe%d]",
			    src2,opchar,src1,loop,fp);
		    break;
		case CHAIN_CRR:
		    sprintf(faspc_ss,
			    "VR%d[%d]%cCN%d->[floating add/sub pipe%d]",
			    src2,loop,opchar,src1,fp);
		    break;
		case CHAIN_CRC:
		    sprintf(faspc_ss,
			    "VR%d[%d]%cCN%d->[floating add/sub pipe%d]",
			    src2,loop,opchar,src1,fp);
		    break;
		case CHAIN_CCR:
		    sprintf(faspc_ss,
			    "CN%d%cCN%d->[floating add/sub pipe%d]",
			    src2,opchar,src1,fp);
		    break;
		case CHAIN_CCC:
		    sprintf(faspc_ss,
			    "CN%d%cCN%d->[floating add/sub pipe%d]",
			    src2,opchar,src1,fp);
		    break;
	    }
	} else if (loop < faspc_vectorlength[fp]) { /* send to/recieve from fasp */
	    switch (chain) {
		case CHAIN_OFF:
		    sprintf(faspc_ss,
			    "VR%d[%d]%cVR%d[%d]->[floating add/sub pipe%d]->VR%d[%d]",
			    src2,loop,opchar,src1,loop,fp,dstn,loop-FASPLEN);
		    break;
		case CHAIN_RRC:
		    sprintf(faspc_ss,
			    "VR%d[%d]%cVR%d[%d]->[floating add/sub pipe%d]->CN%d",
			    src2,loop,opchar,src1,loop,fp,dstn);
		    break;
		case CHAIN_RCR:
		    sprintf(faspc_ss,
			    "CN%d%cVR%d[%d]->[floating add/sub pipe%d]->VR%d[%d]",
			    src2,opchar,src1,loop,fp,dstn,loop-FASPLEN);
		    break;
		case CHAIN_RCC:
		    sprintf(faspc_ss,
			    "CN%d%cVR%d[%d]->[floating add/sub pipe%d]->CN%d",
			    src2,opchar,src1,loop,fp,dstn);
		    break;
		case CHAIN_CRR:
		    sprintf(faspc_ss,
			    "VR%d[%d]%cCN%d->[floating add/sub pipe%d]->VR%d[%d]",
			    src2,loop,opchar,src1,fp,dstn,loop-FASPLEN);
		    break;
		case CHAIN_CRC:
		    sprintf(faspc_ss,
			    "VR%d[%d]%cCN%d->[floating add/sub pipe%d]->CN%d",
			    src2,loop,opchar,src1,fp,dstn);
		    break;
		case CHAIN_CCR:
		    sprintf(faspc_ss,
			    "CN%d%cCN%d->[floating add/sub pipe%d]->VR%d[%d]",
			    src2,opchar,src1,fp,dstn,loop-FASPLEN);
		    break;
		case CHAIN_CCC:
		    sprintf(faspc_ss,
			    "CN%d%cCN%d->[floating add/sub pipe%d]->CN%d",
			    src2,opchar,src1,fp,dstn);
		    break;
	    }
	} else {	/* read from fasp only (loop >= FASPLEN) */
	    switch (chain) {
		case CHAIN_OFF:
		case CHAIN_RCR:
		case CHAIN_CRR:
		case CHAIN_CCR:
		    sprintf(faspc_ss,
			    "[floating add/sub pipe%d]->VR%d[%d]",
			    fp,dstn,loop-FASPLEN);
		    break;
		case CHAIN_RRC:
		case CHAIN_CRC:
		case CHAIN_RCC:
		case CHAIN_CCC:
		    sprintf(faspc_ss,
			    "[floating add/sub pipe%d]->CN%d",
			    fp,dstn);
		    break;
	    }
	}
	switch (chain) {
	    case CHAIN_OFF:
	    case CHAIN_RCR:
	    case CHAIN_CRR:
	    case CHAIN_CCR:
		if (vmr == 0) {
		    sprintf(fstmp,":VMR not used.");
		} else {
		    sprintf(fstmp,"VMR%d[%d]=%s",
			    vmr,loop-FASPLEN,
			    (VMR(vmr,loop-FASPLEN)==TRUE)?"TRUE":"FALSE");
		}
		break;
	}

	strcat(faspc_ss,fstmp);
	return (faspc_ss);
}

/* make status of fmp-controler */
char *fmpc_state(fp,pipeop,src1,src2,dstn,chain,vmr,loop)
int fp;		/* No. of floating mult pipe */
int pipeop;	/* opcode for pipeline */
int src1,src2;	/* source operands */
int dstn;	/* destination operand */
int chain;	/* chaining flag */
int vmr;	/* vector mask reg. */
int loop;	/* loop count for vector reg. access */
{
	char opchar;
	char fstmp[40];

	switch (pipeop) {
		case FOP_MLT:
		    opchar = '*';
		    break;
	}
	if (loop < FMPLEN) { /* send to fmp only */
	    switch (chain) {
		case CHAIN_OFF:
		    sprintf(fmpc_ss,
			    "VR%d[%d]%cVR%d[%d]->[floating mult pipe%d]",
			    src2,loop,opchar,src1,loop,fp);
		    break;
		case CHAIN_RRC:
		    sprintf(fmpc_ss,
			    "VR%d[%d]%cVR%d[%d]->[floating mult pipe%d]",
			    src2,loop,opchar,src1,loop,fp);
		    break;
		case CHAIN_RCR:
		    sprintf(fmpc_ss,
			    "CN%d%cVR%d[%d]->[floating mult pipe%d]",
			    src2,opchar,src1,loop,fp);
		    break;
		case CHAIN_RCC:
		    sprintf(fmpc_ss,
			    "CN%d%cVR%d[%d]->[floating mult pipe%d]",
			    src2,opchar,src1,loop,fp);
		    break;
		case CHAIN_CRR:
		    sprintf(fmpc_ss,
			    "VR%d[%d]%cCN%d->[floating mult pipe%d]",
			    src2,loop,opchar,src1,fp);
		    break;
		case CHAIN_CRC:
		    sprintf(fmpc_ss,
			    "VR%d[%d]%cCN%d->[floating mult pipe%d]",
			    src2,loop,opchar,src1,fp);
		    break;
		case CHAIN_CCR:
		    sprintf(fmpc_ss,
			    "CN%d%cCN%d->[floating mult pipe%d]",
			    src2,opchar,src1,fp);
		    break;
		case CHAIN_CCC:
		    sprintf(fmpc_ss,
			    "CN%d%cCN%d->[floating mult pipe%d]",
			    src2,opchar,src1,fp);
		    break;
	    }
	} else if (loop < fmpc_vectorlength[fp]) { /* send to/recieve from fmp */
	    switch (chain) {
		case CHAIN_OFF:
		    sprintf(fmpc_ss,
			    "VR%d[%d]%cVR%d[%d]->[floating mult pipe%d]->VR%d[%d]",
			    src2,loop,opchar,src1,loop,fp,dstn,loop-FMPLEN);
		    break;
		case CHAIN_RRC:
		    sprintf(fmpc_ss,
			    "VR%d[%d]%cVR%d[%d]->[floating mult pipe%d]->CN%d",
			    src2,loop,opchar,src1,loop,fp,dstn);
		    break;
		case CHAIN_RCR:
		    sprintf(fmpc_ss,
			    "CN%d%cVR%d[%d]->[floating mult pipe%d]->VR%d[%d]",
			    src2,opchar,src1,loop,fp,dstn,loop-FMPLEN);
		    break;
		case CHAIN_RCC:
		    sprintf(fmpc_ss,
			    "CN%d%cVR%d[%d]->[floating mult pipe%d]->CN%d",
			    src2,opchar,src1,loop,fp,dstn);
		    break;
		case CHAIN_CRR:
		    sprintf(fmpc_ss,
			    "VR%d[%d]%cCN%d->[floating mult pipe%d]->VR%d[%d]",
			    src2,loop,opchar,src1,fp,dstn,loop-FMPLEN);
		    break;
		case CHAIN_CRC:
		    sprintf(fmpc_ss,
			    "VR%d[%d]%cCN%d->[floating mult pipe%d]->CN%d",
			    src2,loop,opchar,src1,fp,dstn);
		    break;
		case CHAIN_CCR:
		    sprintf(fmpc_ss,
			    "CN%d%cCN%d->[floating mult pipe%d]->VR%d[%d]",
			    src2,opchar,src1,fp,dstn,loop-FMPLEN);
		    break;
		case CHAIN_CCC:
		    sprintf(fmpc_ss,
			    "CN%d%cCN%d->[floating mult pipe%d]->CN%d",
			    src2,opchar,src1,fp,dstn);
		    break;
	    }
	} else {	/* read from fmp only (loop >= vectorlength) */
	    switch (chain) {
		case CHAIN_OFF:
		case CHAIN_RCR:
		case CHAIN_CRR:
		case CHAIN_CCR:
		    sprintf(fmpc_ss,
			    "[floating mult pipe%d]->VR%d[%d]",
			    fp,dstn,loop-FMPLEN);
		    break;
		case CHAIN_RRC:
		case CHAIN_CRC:
		case CHAIN_RCC:
		case CHAIN_CCC:
		    sprintf(fmpc_ss,
			    "[floating mult pipe%d]->CN%d",
			    fp,dstn);
		    break;
	    }
	}
	switch (chain) {
	    case CHAIN_OFF:
	    case CHAIN_RCR:
	    case CHAIN_CRR:
	    case CHAIN_CCR:
		if (vmr == 0) {
		    sprintf(fstmp,":VMR not used.");
		} else {
		    sprintf(fstmp,"VMR%d[%d]=%s",
			    vmr,loop-FMPLEN,
			    (VMR(vmr,loop-FMPLEN)==TRUE)?"TRUE":"FALSE");
		}
		break;
	}

	strcat(fmpc_ss,fstmp);
	return (fmpc_ss);
}

/* make status of fdp-controler */
char *fdpc_state(fp,pipeop,src1,src2,dstn,chain,vmr,loop)
int fp;		/* No. of floating div pipe */
int pipeop;	/* opcode for pipeline */
int src1,src2;	/* source operands */
int dstn;	/* destination operand */
int chain;	/* chaining flag */
int vmr;	/* vector mask reg. */
int loop;	/* loop count for vector reg. access */
{
	char opchar;
	char fstmp[40];

	switch (pipeop) {
		case FOP_DIV:
		    opchar = '/';
		    break;
	}
	if (loop < FDPLEN) { /* send to fdp only */
	    switch (chain) {
		case CHAIN_OFF:
		    sprintf(fdpc_ss,
			    "VR%d[%d]%cVR%d[%d]->[floating div pipe%d]",
			    src2,loop,opchar,src1,loop,fp);
		    break;
		case CHAIN_RRC:
		    sprintf(fdpc_ss,
			    "VR%d[%d]%cVR%d[%d]->[floating div pipe%d]",
			    src2,loop,opchar,src1,loop,fp);
		    break;
		case CHAIN_RCR:
		    sprintf(fdpc_ss,
			    "CN%d%cVR%d[%d]->[floating div pipe%d]",
			    src2,opchar,src1,loop,fp);
		    break;
		case CHAIN_RCC:
		    sprintf(fdpc_ss,
			    "CN%d%cVR%d[%d]->[floating div pipe%d]",
			    src2,opchar,src1,loop,fp);
		    break;
		case CHAIN_CRR:
		    sprintf(fdpc_ss,
			    "VR%d[%d]%cCN%d->[floating div pipe%d]",
			    src2,loop,opchar,src1,fp);
		    break;
		case CHAIN_CRC:
		    sprintf(fdpc_ss,
			    "VR%d[%d]%cCN%d->[floating div pipe%d]",
			    src2,loop,opchar,src1,fp);
		    break;
		case CHAIN_CCR:
		    sprintf(fdpc_ss,
			    "CN%d%cCN%d->[floating div pipe%d]",
			    src2,opchar,src1,fp);
		    break;
		case CHAIN_CCC:
		    sprintf(fdpc_ss,
			    "CN%d%cCN%d->[floating div pipe%d]",
			    src2,opchar,src1,fp);
		    break;
	    }
	} else if (loop < fdpc_vectorlength[fp]) { /* send to/recieve from fdp */
	    switch (chain) {
		case CHAIN_OFF:
		    sprintf(fdpc_ss,
			    "VR%d[%d]%cVR%d[%d]->[floating div pipe%d]->VR%d[%d]",
			    src2,loop,opchar,src1,loop,fp,dstn,loop-FDPLEN);
		    break;
		case CHAIN_RRC:
		    sprintf(fdpc_ss,
			    "VR%d[%d]%cVR%d[%d]->[floating div pipe%d]->CN%d",
			    src2,loop,opchar,src1,loop,fp,dstn);
		    break;
		case CHAIN_RCR:
		    sprintf(fdpc_ss,
			    "CN%d%cVR%d[%d]->[floating div pipe%d]->VR%d[%d]",
			    src2,opchar,src1,loop,fp,dstn,loop-FDPLEN);
		    break;
		case CHAIN_RCC:
		    sprintf(fdpc_ss,
			    "CN%d%cVR%d[%d]->[floating div pipe%d]->CN%d",
			    src2,opchar,src1,loop,fp,dstn);
		    break;
		case CHAIN_CRR:
		    sprintf(fdpc_ss,
			    "VR%d[%d]%cCN%d->[floating div pipe%d]->VR%d[%d]",
			    src2,loop,opchar,src1,fp,dstn,loop-FDPLEN);
		    break;
		case CHAIN_CRC:
		    sprintf(fdpc_ss,
			    "VR%d[%d]%cCN%d->[floating div pipe%d]->CN%d",
			    src2,loop,opchar,src1,fp,dstn);
		    break;
		case CHAIN_CCR:
		    sprintf(fdpc_ss,
			    "CN%d%cCN%d->[floating div pipe%d]->VR%d[%d]",
			    src2,opchar,src1,fp,dstn,loop-FDPLEN);
		    break;
		case CHAIN_CCC:
		    sprintf(fdpc_ss,
			    "CN%d%cCN%d->[floating div pipe%d]->CN%d",
			    src2,opchar,src1,fp,dstn);
		    break;
	    }
	} else {	/* read from fmdp only (loop >= FDPLEN) */
	    switch (chain) {
		case CHAIN_OFF:
		case CHAIN_RCR:
		case CHAIN_CRR:
		case CHAIN_CCR:
		    sprintf(fdpc_ss,
			    "[floating div pipe%d]->VR%d[%d]",
			    fp,dstn,loop-FDPLEN);
		    break;
		case CHAIN_RRC:
		case CHAIN_CRC:
		case CHAIN_RCC:
		case CHAIN_CCC:
		    sprintf(fdpc_ss,
			    "[floating div pipe%d]->CN%d",
			    fp,dstn);
		    break;
	    }
	}
	switch (chain) {
	    case CHAIN_OFF:
	    case CHAIN_RCR:
	    case CHAIN_CRR:
	    case CHAIN_CCR:
		if (vmr == 0) {
		    sprintf(fstmp,":VMR not used.");
		} else {
		    sprintf(fstmp,"VMR%d[%d]=%s",
			    vmr,loop-FDPLEN,
			    (VMR(vmr,loop-FDPLEN)==TRUE)?"TRUE":"FALSE");
		}
		break;
	}

	strcat(fdpc_ss,fstmp);
	return (fdpc_ss);
}

/* make status of vilp-controler */
char *vilpc_state(vilp,pipeop,src1,src2,src_s,dstn,chain,vmr,loop)
int vilp;	/* No. of vector int/logic pipe */
int pipeop;	/* opcode for pipeline */
int src1,src2;	/* source operands */
word src_s;	/* scalar source operand */
int dstn;	/* destination operand */
int chain;	/* chaining flag */
int vmr;	/* vector mask reg. */
int loop;	/* loop count for vector reg. access */
{
	char opstr[20];
	char vstmp[40];

        switch (pipeop) {
            case VILPOP_ADD:
		strcpy(opstr,"+");
		break;
            case VILPOP_SUB:
		strcpy(opstr,"-");
		break;
            case VILPOP_MUL:
		strcpy(opstr,"*");
		break;
            case VILPOP_DIV:
		strcpy(opstr,"/");
		break;
            case VILPOP_AND:
		strcpy(opstr," AND ");
		break;
            case VILPOP_OR:
		strcpy(opstr," OR ");
		break;
            case VILPOP_XOR:
		strcpy(opstr," XOR ");
		break;
            case VILPOP_NOT:
		strcpy(opstr,"NOT ");
		break;
            case VILPOP_I2F:
		strcpy(opstr,"(float)");
		break;
            case VILPOP_F2I:
		strcpy(opstr,"(int)");
		break;
            case VILPOP_ICZ:
		strcpy(opstr,"int-compare-0 ");
		break;
            case VILPOP_FCZ:
		strcpy(opstr,"float-compare-0 ");
		break;
            case VILPOP_SLL:
		strcpy(opstr," << ");
		break;
            case VILPOP_SRL:
		strcpy(opstr," >> ");
		break;
            case VILPOP_BC:
		strcpy(opstr," broadcast ");
		break;
	}
	
	if (loop < VILPLEN) { /* send to vilp only */
	    switch (pipeop) {
		case VILPOP_ADD:
		case VILPOP_SUB:
		case VILPOP_MUL:
		case VILPOP_DIV:
		case VILPOP_AND:
		case VILPOP_OR:
		case VILPOP_XOR:
		    switch (chain) {
			case CHAIN_OFF:
			    sprintf(vilpc_ss,
				    "VR%d[%d]%sVR%d[%d]->[vector int/logic pipe%d]",
				    src2,loop,opstr,src1,loop,vilp);
			    break;
			case CHAIN_RRC:
			    sprintf(vilpc_ss,
				    "VR%d[%d]%sVR%d[%d]->[vector int/logic pipe%d]",
				    src2,loop,opstr,src1,loop,vilp);
			    break;
			case CHAIN_RCR:
			    sprintf(vilpc_ss,
				    "CN%d%sVR%d[%d]->[vector int/logic pipe%d]",
				    src2,opstr,src1,loop,vilp);
			    break;
			case CHAIN_RCC:
			    sprintf(vilpc_ss,
				    "CN%d%sVR%d[%d]->[vector int/logic pipe%d]",
				    src2,opstr,src1,loop,vilp);
			    break;
			case CHAIN_CRR:
			    sprintf(vilpc_ss,
				    "VR%d[%d]%sCN%d->[vector int/logic pipe%d]",
				    src2,loop,opstr,src1,vilp);
			    break;
			case CHAIN_CRC:
			    sprintf(vilpc_ss,
				    "VR%d[%d]%sCN%d->[vector int/logic pipe%d]",
				    src2,loop,opstr,src1,vilp);
			    break;
			case CHAIN_CCR:
			    sprintf(vilpc_ss,
				    "CN%d%sCN%d->[vector int/logic pipe%d]",
				    src2,opstr,src1,vilp);
			    break;
			case CHAIN_CCC:
			    sprintf(vilpc_ss,
				    "CN%d%sCN%d->[vector int/logic pipe%d]",
				    src2,opstr,src1,vilp);
			    break;
		    }
		    break;
		case VILPOP_SLL:
		case VILPOP_SRL:
		    switch (chain) {
			case CHAIN_OFF:
			case CHAIN_RCR:
			    sprintf(vilpc_ss,
				    "VR%d[%d]%s%d->[vector int/logic pipe%d]",
				    src1,loop,opstr,src_s.i,vilp);
			    break;
			case CHAIN_RRC:
			case CHAIN_RCC:
			    sprintf(vilpc_ss,
				    "VR%d[%d]%s%d->[vector int/logic pipe%d]",
				    src1,loop,opstr,src_s.i,vilp);
			    break;
			case CHAIN_CRR:
			case CHAIN_CCR:
			    sprintf(vilpc_ss,
				    "CN%d%s%d->[vector int/logic pipe%d]",
				    src1,opstr,src_s.i,vilp);
			    break;
			case CHAIN_CRC:
			case CHAIN_CCC:
			    sprintf(vilpc_ss,
				    "CN%d%s%d->[vector int/logic pipe%d]",
				    src1,opstr,src_s.i,vilp);
			    break;
		    }
		    break;
		case VILPOP_NOT:
		case VILPOP_I2F:
		case VILPOP_F2I:
		case VILPOP_ICZ:
		case VILPOP_FCZ:
		    switch (chain) {
			case CHAIN_OFF:
			case CHAIN_RCR:
			    sprintf(vilpc_ss,
				    "%sVR%d[%d]->[vector int/logic pipe%d]",
				    opstr,src1,loop,vilp);
			    break;
			case CHAIN_RRC:
			case CHAIN_RCC:
			    sprintf(vilpc_ss,
				    "%sVR%d[%d]->[vector int/logic pipe%d]",
				    opstr,src1,loop,vilp);
			    break;
			case CHAIN_CRR:
			case CHAIN_CCR:
			    sprintf(vilpc_ss,
				    "%sCN%d->[vector int/logic pipe%d]",
				    opstr,src1,vilp);
			    break;
			case CHAIN_CRC:
			case CHAIN_CCC:
			    sprintf(vilpc_ss,
				    "%sCN%d->[vector int/logic pipe%d]",
				    opstr,src1,vilp);
			    break;
		    }
		    break;
		case VILPOP_BC:
		    switch (chain) {
			case CHAIN_OFF:
			case CHAIN_RCR:
			case CHAIN_CRR:
			case CHAIN_CCR:
			    sprintf(vilpc_ss,
				    "%s%d(%f)->[vector int/logic pipe%d]",
				    opstr,src_s.i,src_s.f,vilp);
			    break;
			case CHAIN_RRC:
			case CHAIN_RCC:
			case CHAIN_CRC:
			case CHAIN_CCC:
			    sprintf(vilpc_ss,
				    "%s%d(%f)->[vector int/logic pipe%d]",
				    opstr,src_s.i,src_s.f,vilp);
			    break;
		    
		    }
		    break;
	    }
	} else if (loop < vilpc_vectorlength[vilp]) { /* send to/recieve from vilp */
	    switch (pipeop) {
		case VILPOP_ADD:
		case VILPOP_SUB:
		case VILPOP_MUL:
		case VILPOP_DIV:
		case VILPOP_AND:
		case VILPOP_OR:
		case VILPOP_XOR:
		    switch (chain) {
			case CHAIN_OFF:
			    sprintf(vilpc_ss,
				    "VR%d[%d]%sVR%d[%d]->[vector int/logic pipe%d]->VR%d[%d]",
				    src2,loop,opstr,src1,loop,vilp,dstn,loop-VILPLEN);
			    break;
			case CHAIN_RRC:
			    sprintf(vilpc_ss,
				    "VR%d[%d]%sVR%d[%d]->[vector int/logic pipe%d]->CN%d",
				    src2,loop,opstr,src1,loop,vilp,dstn);
			    break;
			case CHAIN_RCR:
			    sprintf(vilpc_ss,
				    "CN%d%sVR%d[%d]->[vector int/logic pipe%d]->VR%d[%d]",
				    src2,opstr,src1,loop,vilp,dstn,loop-VILPLEN);
			    break;
			case CHAIN_RCC:
			    sprintf(vilpc_ss,
				    "CN%d%sVR%d[%d]->[vector int/logic pipe%d]->CN%d",
				    src2,opstr,src1,loop,vilp,dstn);
			    break;
			case CHAIN_CRR:
			    sprintf(vilpc_ss,
				    "VR%d[%d]%sCN%d->[vector int/logic pipe%d]->VR%d[%d]",
				    src2,loop,opstr,src1,vilp,dstn,loop-VILPLEN);
			    break;
			case CHAIN_CRC:
			    sprintf(vilpc_ss,
				    "VR%d[%d]%sCN%d->[vector int/logic pipe%d]->CN%d",
				    src2,loop,opstr,src1,vilp,dstn);
			    break;
			case CHAIN_CCR:
			    sprintf(vilpc_ss,
				    "CN%d%sCN%d->[vector int/logic pipe%d]->VR%d[%d]",
				    src2,opstr,src1,vilp,dstn,loop-VILPLEN);
			    break;
			case CHAIN_CCC:
			    sprintf(vilpc_ss,
				    "CN%d%sCN%d->[vector int/logic pipe%d]->CN%d",
				    src2,opstr,src1,vilp,dstn);
			    break;
		    }
		    break;
		case VILPOP_SLL:
		case VILPOP_SRL:
		    switch (chain) {
			case CHAIN_OFF:
			case CHAIN_RCR:
			    sprintf(vilpc_ss,
				    "VR%d[%d]%s%d->[vector int/logic pipe%d]->VR%d[%d]",
				    src1,loop,opstr,src_s.i,vilp,dstn,loop-VILPLEN);
			    break;
			case CHAIN_RRC:
			case CHAIN_RCC:
			    sprintf(vilpc_ss,
				    "VR%d[%d]%s%d->[vector int/logic pipe%d]->CN%d",
				    src1,loop,opstr,src_s.i,vilp,dstn);
			    break;
			case CHAIN_CRR:
			case CHAIN_CCR:
			    sprintf(vilpc_ss,
				    "CN%d%s%d->[vector int/logic pipe%d]->VR%d[%d]",
				    src1,opstr,src_s.i,vilp,dstn,loop-VILPLEN);
			    break;
			case CHAIN_CRC:
			case CHAIN_CCC:
			    sprintf(vilpc_ss,
				    "CN%d%s%d->[vector int/logic pipe%d]->CN%d",
				    src1,opstr,src_s.i,vilp,dstn);
			    break;
		    }
		    break;
		case VILPOP_NOT:
		case VILPOP_I2F:
		case VILPOP_F2I:
		case VILPOP_ICZ:
		case VILPOP_FCZ:
		    switch (chain) {
			case CHAIN_OFF:
			case CHAIN_RCR:
			    sprintf(vilpc_ss,
				    "%sVR%d[%d]->[vector int/logic pipe%d]->VR%d[%d]",
				    opstr,src1,loop,vilp,dstn,loop-VILPLEN);
			    break;
			case CHAIN_RRC:
			case CHAIN_RCC:
			    sprintf(vilpc_ss,
				    "%sVR%d[%d]->[vector int/logic pipe%d]->CN%d",
				    opstr,src1,loop,vilp,dstn);
			    break;
			case CHAIN_CRR:
			case CHAIN_CCR:
			    sprintf(vilpc_ss,
				    "%sCN%d->[vector int/logic pipe%d]->VR%d[%d]",
				    opstr,src1,vilp,dstn,loop-VILPLEN);
			    break;
			case CHAIN_CRC:
			case CHAIN_CCC:
			    sprintf(vilpc_ss,
				    "%sCN%d->[vector int/logic pipe%d]->CN%d",
				    opstr,src1,vilp,dstn);
			    break;
		    }
		    break;
		case VILPOP_BC:
		    switch (chain) {
			case CHAIN_OFF:
			case CHAIN_RCR:
			case CHAIN_CRR:
			case CHAIN_CCR:
			    sprintf(vilpc_ss,
				    "%s%d(%f)->[vector int/logic pipe%d]->VR%d[%d]",
				    opstr,src_s.i,src_s.f,vilp,dstn,loop-VILPLEN);
			    break;
			case CHAIN_RRC:
			case CHAIN_RCC:
			case CHAIN_CRC:
			case CHAIN_CCC:
			    sprintf(vilpc_ss,
				    "%s%d(%f)->[vector int/logic pipe%d]->CN%d",
				    opstr,src_s.i,src_s.f,vilp,dstn);
			    break;
		    
		    }
		    break;
	    }
	} else {	/* read from vilp only (loop >= VILPLEN) */
	    switch (chain) {
		case CHAIN_OFF:
		case CHAIN_RCR:
		case CHAIN_CRR:
		case CHAIN_CCR:
		    sprintf(vilpc_ss,
			    "[vector int/logic pipe%d]->VR%d[%d]",
			    vilp,dstn,loop-VILPLEN);
		    break;
		case CHAIN_RRC:
		case CHAIN_RCC:
		case CHAIN_CRC:
		case CHAIN_CCC:
		    sprintf(vilpc_ss,
			    "[vector int/logic pipe%d]->CN%d",
			    vilp,dstn);
		    break;
	    }
	}

	switch (chain) {
            case CHAIN_OFF:
            case CHAIN_RCR:
            case CHAIN_CRR:
            case CHAIN_CCR:
                if (vmr == 0) {
                    sprintf(vstmp,":VMR not used.");
                } else {
                    sprintf(vstmp,"VMR%d[%d]=%s",
                            vmr,loop-VILPLEN,
                            (VMR(vmr,loop-VILPLEN)==TRUE)?"TRUE":"FALSE");
                }
                break;
        }

        strcat(vilpc_ss,vstmp);
        return (vilpc_ss);
}
