/* pipe-sim(+vector) ver.3.0 [92/05/28-7/29] */
/*		     ver.3.4a[92/09/16] */
/* vector float/int-logic pipe controller latches and defines */

#include "global.h"

global int faspop[NFASP];
global int faspchain[NFASP];
global int faspsrc1[NFASP];
global int faspsrc2[NFASP];
global int faspdstn[NFASP];
global int faspvmr[NFASP];

global int fmpop[NFMP];
global int fmpchain[NFMP];
global int fmpsrc1[NFMP];
global int fmpsrc2[NFMP];
global int fmpdstn[NFMP];
global int fmpvmr[NFMP];

global int fdpop[NFDP];
global int fdpchain[NFDP];
global int fdpsrc1[NFDP];
global int fdpsrc2[NFDP];
global int fdpdstn[NFDP];
global int fdpvmr[NFDP];

global int vilpop[NVILP];
global int vilpchain[NVILP];
global int vilpsrc1[NVILP];
global int vilpsrc2[NVILP];
global word vilpscalarsrc[NVILP];
global int vilpdstn[NVILP];
global int vilpvmr[NVILP];
global int vilpvmrcond[NVILP];

global int faspcflag[NFASP],fmpcflag[NFMP],fdpcflag[NFDP];
global int vilpcflag[NVILP];

global int faspc_vectorlength[NFASP];
global int fmpc_vectorlength[NFASP];
global int fdpc_vectorlength[NFASP];
global int vilpc_vectorlength[NFASP];

/* FASPC (vector Float Add/Sub Pipeline Control unit) state flags */
#define FASPC_NOP	0
#define FASPC_INIT	1
#define FASPC_RUN	2

/* FMPC (vector Float Mult Pipeline Control unit) state flags */
#define FMPC_NOP	0
#define FMPC_INIT	1
#define FMPC_RUN	2

/* FDPC (vector Float Div Pipeline Control unit) state flags */
#define FDPC_NOP	0
#define FDPC_INIT	1
#define FDPC_RUN	2

/* VILPC (Vector Int/Logic Pipeline Control unit) state flags */
#define VILPC_NOP	0
#define VILPC_INIT	1
#define VILPC_RUN	2

static char *pipectl_flag[]={"no-operation","initializing","running"};

extern char *faspc_state();
extern char *fmpc_state();
extern char *fdpc_state();
extern char *vilpc_state();

/* encode  vector src/dst registers */
#define VR_ENCODE(reg,pos) (((reg) << 8)|((pos) & 0xff))

/* decode  vector src/dst registers */
#define VR_DECODE_REG(dst) ((dst) >> 8)
#define VR_DECODE_POS(dst) ((dst) & 0xff)
