/* pipe-sim(+vector) ver.3.0 [92/05/28-7/29] */
/*		     ver.3.4 [92/09/14] */
/* pipe-sim(+vector) ver.4.3 [94/12/26-95/01/20] */
/*                   ver.4.3c[96/08/12] */
/* vector store unit */

#include "defines.h"
#include "latches.h"
#include "vectorls.h"
#include "cmnvar.h"
#include "opcode.h"
#include "memwait.h"

static int vsu_inst[NIP],vsu_incr[NIP],vsu_base[NIP],vsu_src[NIP];
static int vsu_vmr[NIP],vsu_lstv[NIP];
static int vsu_vectorlength[NIP];
static int storeloop[NIP];

static char vsu0_status[NIP][SSLEN];
static char vsu1_status[NIP][SSLEN];

char *vsu0(ip)
int	ip;
{
	int	memaddr;
	char    vsu0tmp[40];

	switch(vsuflag[ip]) {
	    case VLSU_NOP: /* no operation */
		strcpy(vsu0_status[ip],"no operation");
		break;
	    case VLSU_ADDRSET: /* store addr set to vsu */
		switch(vstoreinst[ip]) {
		    case VOP_STIR:
		    case VOP_STII:
			vsu_inst[ip] = vstoreinst[ip];
			vsu_incr[ip] = vstoreincr[ip];
			vsu_base[ip] = vstorebase[ip];
			vsu_src[ip] = vstoresrc[ip];
			vsu_vmr[ip] = vstorevmr[ip];
			vsu_vectorlength[ip] = SPECIALREG(N_VSCR+ip).i;

			/*
                         * λǥѥ᡼Ѥ
			 * ١ɥ쥹:vsu_base
			 * ʬ          :vsu_incr
			 * ٥ȥĹ    :vsu_vectorlength
			 * Ԥʸmemwait
			*/
			v_writememwait[ip] += 0;

			storeloop[ip] = 0;
			memaddr = vsu_base[ip];
			if ((memaddr < 0)||(memaddr >= MEMSIZE)) {
			    /* irregal addr. access */
			    error("bus error",
				  "vector store unit phase 0",ip);
			} else if ((memaddr < SPECIALREG(N_PSH).i)&&
				   (memaddr >= SPECIALREG(N_PSL).i)) {
			    /* irregal addr. access (program area) */
			    error("segmentation fault",
				  "vector store unit phase 0",ip);
			} else {
			    if (VMR(vsu_vmr[ip],storeloop[ip])==TRUE) {
				memory[memaddr] = vectorreg[vsu_src[ip]][storeloop[ip]];
			    }
			}

                        sprintf(vsu0_status[ip],
                            "VST addr-set(baseaddr=0x%X,increment=%d);VR%d[%d]->memory[0x%X]",
                            vsu_base[ip],vsu_incr[ip],
                            vsu_src[ip],storeloop[ip],memaddr);
                        if (vsu_vmr[ip] == 0) {
                            sprintf(vsu0tmp,":VMR not used.");
                        } else {
                            sprintf(vsu0tmp,":VMR%d[%d]=%s",
                            vsu_vmr[ip],storeloop[ip],
                            (VMR(vsu_vmr[ip],storeloop[ip])==TRUE)?"TRUE":"FALSE");
                        }
                        strcat(vsu0_status[ip],vsu0tmp);

                        /* decrement Vector Store Count Reg. */
			SPECIALREG(N_VSCR+ip).i--;

			storeloop[ip]++;
			vsuflag[ip] = VLSU_RUN;
			break;
		    case VOP_LVST:
		    case VOP_LVBST:
		        vsu_inst[ip] = vstoreinst[ip];
			vsu_lstv[ip] = vstorelstv[ip];
			vsu_base[ip] = vstorebase[ip];
			vsu_src[ip] = vstoresrc[ip];
			vsu_vmr[ip] = vstorevmr[ip];
			vsu_vectorlength[ip] = SPECIALREG(N_VSCR+ip).i;
			storeloop[ip] = 0;
			memaddr = vsu_base[ip]+vectorreg[vsu_lstv[ip]][storeloop[ip]].i;
			if (VMR(vsu_vmr[ip],storeloop[ip])==TRUE) {
			    if ((memaddr < 0)||(memaddr >= MEMSIZE)) {
				/* irregal addr. access */
				error("bus error",
				      "vector store unit phase 0",ip);
			    } else if ((memaddr < SPECIALREG(N_PSH).i)&&
				       (memaddr >= SPECIALREG(N_PSL).i)) {
				/* irregal addr. access (program area) */
				error("segmentation fault",
				      "vector store unit phase 0",ip);
			    } else {
				memory[memaddr] = vectorreg[vsu_src[ip]][storeloop[ip]];
			    }
			}

                        sprintf(vsu0_status[ip],
                            "LVST addr-set(baseaddr=0x%X,listVR=%d);VR%d[%d]->memory[0x%X]",
                            vsu_base[ip],vsu_lstv[ip],
                            vsu_src[ip],storeloop[ip],memaddr);
                        if (vsu_vmr[ip] == 0) {
                            sprintf(vsu0tmp,":VMR not used.");
                        } else {
                            sprintf(vsu0tmp,":VMR%d[%d]=%s",
                            vsu_vmr[ip],storeloop[ip],
                            (VMR(vsu_vmr[ip],storeloop[ip])==TRUE)?"TRUE":"FALSE");
                        }
                        strcat(vsu0_status[ip],vsu0tmp);

                        /* decrement Vector Store Count Reg. */
			SPECIALREG(N_VSCR+ip).i--;

			storeloop[ip]++;
			vsuflag[ip] = VLSU_RUN;
			break;
		}
		break;	/* end of case VLSU_ADDRSET */
	    case VLSU_RUN:  /* vsu is running */
		switch(vsu_inst[ip]) {
		    case VOP_STIR:
		    case VOP_STII:
			memaddr = vsu_base[ip] + vsu_incr[ip] * storeloop[ip];
			if (VMR(vsu_vmr[ip],storeloop[ip])==TRUE) {
			    if ((memaddr < 0)||(memaddr >= MEMSIZE)) {
				/* irregal addr. access */
				error("bus error",
				      "vector store unit phase 0",ip);
			    } else if ((memaddr < SPECIALREG(N_PSH).i)&&
				       (memaddr >= SPECIALREG(N_PSL).i)) {
				/* irregal addr. access (program area) */
				error("segmentation fault",
				      "vector store unit phase 0",ip);
			    } else {
				memory[memaddr] = vectorreg[vsu_src[ip]][storeloop[ip]];
			    }
			}

                        sprintf(vsu0_status[ip],
                            "VST running ; VR%d[%d]->memory[0x%X]",
                            vsu_src[ip],storeloop[ip],memaddr);
                        if (vsu_vmr[ip] == 0) {
                            sprintf(vsu0tmp,":VMR not used.");
                        } else {
                            sprintf(vsu0tmp,":VMR%d[%d]=%s",
                            vsu_vmr[ip],storeloop[ip],
                            (VMR(vsu_vmr[ip],storeloop[ip])==TRUE)?"TRUE":"FALSE");
                        }
                        strcat(vsu0_status[ip],vsu0tmp);

                        /* decrement Vector Store Count Reg. */
			SPECIALREG(N_VSCR+ip).i--;

			if (++storeloop[ip]==vsu_vectorlength[ip]) vsuflag[ip] = VLSU_NOP;
			break;
		    case VOP_LVST:
		    case VOP_LVBST:
			memaddr = vsu_base[ip]+vectorreg[vsu_lstv[ip]][storeloop[ip]].i;
			if (VMR(vsu_vmr[ip],storeloop[ip])==TRUE) {
			    if ((memaddr < 0)||(memaddr >= MEMSIZE)) {
				/* irregal addr. access */
				error("bus error",
				      "vector store unit phase 0",ip);
			    } else if ((memaddr < SPECIALREG(N_PSH).i)&&
				       (memaddr >= SPECIALREG(N_PSL).i)) {
				/* irregal addr. access (program area) */
				error("segmentation fault",
				      "vector store unit phase 0",ip);
			    } else {
				memory[memaddr] = vectorreg[vsu_src[ip]][storeloop[ip]];
			    }
			}

                        sprintf(vsu0_status[ip],
                            "LVST running ; VR%d[%d]->memory[0x%X]",
                            vsu_src[ip],storeloop[ip],memaddr);
                        if (vsu_vmr[ip] == 0) {
                            sprintf(vsu0tmp,":VMR not used.");
                        } else {
                            sprintf(vsu0tmp,":VMR%d[%d]=%s",
                            vsu_vmr[ip],storeloop[ip],
                            (VMR(vsu_vmr[ip],storeloop[ip])==TRUE)?"TRUE":"FALSE");
                        }
                        strcat(vsu0_status[ip],vsu0tmp);

                        /* decrement Vector Store Count Reg. */
			SPECIALREG(N_VSCR+ip).i--;

			if (++storeloop[ip]==vsu_vectorlength[ip]) vsuflag[ip] = VLSU_NOP;
			break;
		}
		break;	/* end of case VLSU_RUN */
	} /* end of switch(vsuflag[ip]) */
        
        /* return status */
        return(vsu0_status[ip]);
}

char *vsu1(ip)
int	ip;
{
	int	memaddr;
	char    vsu1tmp[40];

	switch(vsuflag[ip]) {
	    case VLSU_NOP: /* no operation */
		strcpy(vsu1_status[ip],"no operation");
		break;
	    case VLSU_RUN:  /* vsu is running */
		switch(vsu_inst[ip]) {
		    case VOP_STIR:
		    case VOP_STII:
                        sprintf(vsu1_status[ip], "VST running ;");
			break;
		    case VOP_LVST:
		    case VOP_LVBST:
                        sprintf(vsu1_status[ip], "LVST running ;");
			break;
		}
		break;	/* end of case VLSU_RUN */
	} /* end of switch(vsuflag[ip]) */
        
        /* return status */
        return(vsu1_status[ip]);
}

/* following codes are not used. */
#define NOTUSED
#ifndef NOTUSED
char *vsu1(ip)
int	ip;
{
	int	memaddr;
	char    vsu1tmp[40];

	switch(vsuflag[ip]) {
	    case VLSU_NOP: /* no operation */
		strcpy(vsu1_status[ip],"no operation");
		break;
	    case VLSU_RUN:  /* vsu is running */
		switch(vsu_inst[ip]) {
		    case VOP_STIR:
		    case VOP_STII:
			memaddr = vsu_base[ip] + vsu_incr[ip] * storeloop[ip];
			if (VMR(vsu_vmr[ip],storeloop[ip])==TRUE) {
			    if ((memaddr < 0)||(memaddr >= MEMSIZE)) {
				/* irregal addr. access */
				error("bus error",
				      "vector store unit phase 1",ip);
			    } else {
				memory[memaddr] = vectorreg[vsu_src[ip]][storeloop[ip]];
			    }
			}

                        sprintf(vsu1_status[ip],
                            "VST running ; VR%d[%d]->memory[0x%X]",
                            vsu_src[ip],storeloop[ip],memaddr);
                        if (vsu_vmr[ip] == 0) {
                            sprintf(vsu1tmp,":VMR not used.");
                        } else {
                            sprintf(vsu1tmp,":VMR%d[%d]=%s",
                            vsu_vmr[ip],storeloop[ip],
                            (VMR(vsu_vmr[ip],storeloop[ip])==TRUE)?"TRUE":"FALSE");
                        }
                        strcat(vsu1_status[ip],vsu1tmp);

			if (++storeloop[ip]==VREGLEN) vsuflag[ip] = VLSU_NOP;
			break;
		    case VOP_LVST:
		    case VOP_LVBST:
			memaddr = vsu_base[ip]+vectorreg[vsu_lstv[ip]][storeloop[ip]].i;
			if (VMR(vsu_vmr[ip],storeloop[ip])==TRUE) {
			    if ((memaddr < 0)||(memaddr >= MEMSIZE)) {
				/* irregal addr. access */
				error("bus error",
				      "vector store unit phase 1",ip);
			    } else {
				memory[memaddr] = vectorreg[vsu_src[ip]][storeloop[ip]];
			    }
			}

                        sprintf(vsu1_status[ip],
                            "LVST running ; VR%d[%d]->memory[0x%X]",
                            vsu_src[ip],storeloop[ip],memaddr);
                        if (vsu_vmr[ip] == 0) {
                            sprintf(vsu1tmp,":VMR not used.");
                        } else {
                            sprintf(vsu1tmp,":VMR%d[%d]=%s",
                            vsu_vmr[ip],storeloop[ip],
                            (VMR(vsu_vmr[ip],storeloop[ip])==TRUE)?"TRUE":"FALSE");
                        }
                        strcat(vsu1_status[ip],vsu1tmp);

			if (++storeloop[ip]==VREGLEN) vsuflag[ip] = VLSU_NOP;
			break;
		}
		break;	/* end of case VLSU_RUN */
	} /* end of switch(vsuflag[ip]) */
        
        /* return status */
        return(vsu1_status[ip]);
}
#endif
